#include "Global.h"
#include "Rat.h"

#define	FIB_Nmax	EQUA_Nmax
#define FIB_PERM	(10)		    /* print permutation for p<=# */

#undef	OLD_IPS

#define GL_Long		Long		    /* uses W_to_GLZ like in Rat.c */
#define SL_Long		LLong		    /* has same problems as REgcd */

#if	(POLY_Dmax < 5)

#define NFX_Limit       903		/* 138b->255  153e->279  165c->327 */
#define X_Limit         9999		   /* 178c->375  218->399,462,483 */
#define VPM_Limit	9999

#else

#define NFX_Limit  1631721   /* 1631721 1 903 37947 233103 543907 815860    */
#define X_Limit    3263441   /* 3263442 1 1806 75894 466206 1087814 1631721 */
#define VPM_Limit  3263442   /* 1631721 1 903 37947 233103 543907 815860    */

#endif

/*   ------	some flags for testing	------ */

#define TEST_GLZ_VS_SL	(0)		/* exit on difference: GL vs. SL */
#define SHOW_NFX_LIMIT	(1)		/* exit on NFX_LIMIT violation */

#undef  WARN_BIG_NS			/* [1152] ...  1152 = sym(24-cell)  */
#undef	SHOW_BIG_NS			/* [1153] ...  printf VPM and exit  */

/*   ------  local typedefs and headers	------ */

typedef struct {int C[VERT_Nmax], L[VERT_Nmax], s;}             PERM;
typedef struct {int nv, nf, ns;}  				vNF;

/*   ------	some useful routines	------ */

void NF_Coordinates(PolyPointList *_P, VertexNumList *_V, EqList *_F);

int  GLZ_Make_Trian_NF(Long X[][VERT_Nmax], int *n, int *nv,
		       GL_Long G[POLY_Dmax][POLY_Dmax]);    /* current=best */

int  SL2Z_Make_Poly_NF(Long X[][VERT_Nmax], int *n, int *nv,
		       SL_Long S[POLY_Dmax][POLY_Dmax]);    /* previous=bad */

int  Init_rVM_VPM(PolyPointList *P, VertexNumList *_V,EqList *_F,/* in */
	    	int *d,int *v,int *f, Long VM[POLY_Dmax][VERT_Nmax], /* out */
	    	Long VPM[VERT_Nmax][VERT_Nmax]);	/* return reflexive */

void Eval_Poly_NF(int *d,int *v,int *f, Long VM[POLY_Dmax][VERT_Nmax],
		Long VPM[VERT_Nmax][VERT_Nmax],			      /* in */
		Long pNF[POLY_Dmax][VERT_Nmax], int t);		     /* out */

void Make_VPM_NF(int *v, int *f, Long VPM[VERT_Nmax][VERT_Nmax],      /* in */
		PERM *CL,int *ns,Long VPM_NF[VERT_Nmax][VERT_Nmax]); /* out */

void Aux_pNF_from_vNF(PERM *CL,int *ns,int *v,int *d,
		Long VM[POLY_Dmax][VERT_Nmax],			      /* in */
		Long pNF[POLY_Dmax][VERT_Nmax],int *t);		     /* out */

void New_pNF_Order(int *v,int *f,PERM *CL,int *ns,Long VPM_NF[][VERT_Nmax]);

int  Make_Poly_NF(PolyPointList *_P, VertexNumList *_V, EqList *_F,
		Long pNF[POLY_Dmax][VERT_Nmax]);	  /* 1 if reflexive */

/*     	==============================================================      */

int  Aux_Make_Poly_NF(Long X[][VERT_Nmax], int *n, int *nv)
{    GL_Long G[POLY_Dmax][POLY_Dmax];
#if	(TEST_GLZ_VS_SL)
     int i,j,x; SL_Long S[POLY_Dmax][POLY_Dmax];Long XS[POLY_Dmax][VERT_Nmax];
     for(i=0;i<*n;i++)for(j=0;j<*nv;j++)XS[i][j]=X[i][j];
     x=GLZ_Make_Trian_NF(X,n,nv,G); SL2Z_Make_Poly_NF(XS,n,nv,S);
     for(i=0;i<*n;i++)for(j=0;j<*n;j++)  assert( S[i][j]==G[i][j]);
     for(i=0;i<*n;i++)for(j=0;j<*nv;j++) assert(XS[i][j]==X[i][j]);
	return x;
#else
	return GLZ_Make_Trian_NF(X,n,nv,G);
#endif
}
void Make_Poly_UTriang(PolyPointList *P)
{    if(VERT_Nmax<P->np) puts("Triang Form requires VERT_Nmax>=#Points"); else
     {	int i,j; Long UTF[POLY_Dmax][VERT_Nmax];
	for(i=0;i<P->np;i++)for(j=0;j<P->n;j++)UTF[j][i]=P->x[i][j];
	Aux_Make_Poly_NF(UTF,&P->n,&P->np);
	for(i=0;i<P->np;i++)for(j=0;j<P->n;j++)P->x[i][j]=UTF[j][i];
     }
}
/*     	==============================================================      */

GL_Long GL_Egcd(GL_Long A0, GL_Long A1, GL_Long *Vout0, GL_Long *Vout1)  
{    GL_Long V0=A0, V1=A1, A2, X0=1, X1=0, X2=0;
     while(A2 = A0 % A1) { X2=X0-X1*(A0/A1); A0=A1; A1=A2; X0=X1; X1=X2; }
     *Vout0=X1, *Vout1=(A1-(V0) * X1)/ (V1); return A1;
}
GL_Long GL_RoundQ(GL_Long N,GL_Long D)
{    GL_Long F; if(D<0) {D=-D; N=-N;} F=N/D; return F+(2*(N-F*D))/D; 
}
GL_Long GL_W_to_GLZ(GL_Long *W, int d, GL_Long **GLZ)		
{    int i, j; GL_Long G, *E=*GLZ, *B=GLZ[1];for(i=0;i<d;i++)assert(W[i]!=0);
     for(i=1;i<d;i++)for(j=0;j<d;j++)GLZ[i][j]=0;
     G=Egcd(W[0],W[1],&E[0],&E[1]); B[0]=-W[1]/G; B[1]=W[0]/G;
     for(i=2;i<d;i++)                   
     {  GL_Long a, b, g=Egcd(G,W[i],&a,&b); B=GLZ[i];
        B[i]= G/g; G=W[i]/g; for(j=0;j<i;j++) B[j]=-E[j]*G;  /* B=Base-Line */
        for(j=0;j<i;j++) E[j]*=a; E[j]=b;                     /* next Egcd */
        for(j=i-1;0<j;j--)                         /* I M P R O V E M E N T */
	{   GL_Long *Y=GLZ[j],rB=GL_RoundQ(B[j],Y[j]),rE=GL_RoundQ(E[j],Y[j]);
            int n; for(n=0;n<=j;n++) { B[n] -= rB*Y[n]; E[n] -= rE*Y[n]; } 
	}   G=g;
     } 
     return G;
}
int  GLZ_Make_Trian_NF(Long X[][VERT_Nmax], int *n, int *nv,
		       			       GL_Long G[POLY_Dmax][POLY_Dmax])
{    int i, j, C=-1, L; GL_Long g, W[POLY_Dmax], NF[POLY_Dmax][VERT_Nmax], 
	*_G[POLY_Dmax], NG[POLY_Dmax][POLY_Dmax];for(i=0;i<*n;i++)_G[i]=NG[i];
     for(i=0;i<*n;i++)for(j=0;j<*n;j++)G[i][j]=(i==j);		  /* init G */
     for(i=0;i<*n;i++)for(j=0;j<*nv;j++)NF[i][j]=0; 
     for(L=0;L<*n;L++)
     {  int N=0, p[POLY_Dmax];
        while(N==0)               /* find column C with N>0 non-zero entries */
        {   ++C; for(i=0;i<*n;i++) 
	    {	for(j=0;j<*n;j++) NF[i][C]+=G[i][j]*X[j][C];
	    }
	    for(i=L;i<*n;i++) if(NF[i][C]) {W[N]=NF[i][C]; p[N++]=i;}
	}
        assert(N); if(N==1) {g=W[0]; _G[0][0]=1;} else g=GL_W_to_GLZ(W,N,_G);
	if(g<0) { g *= -1; for(i=0;i<N;i++)_G[0][i] *= -1; }
	NF[L][C]=g; for(i=L+1;i<*n;i++) NF[i][C]=0;
        for(i=0;i<*n;i++)
	{   GL_Long Cp[POLY_Dmax]; for(j=0;j<N;j++) Cp[j]=G[p[j]][i];
	    for(j=0;j<N;j++) 
	    {	int k; G[p[j]][i]=0; 
		for(k=0;k<N;k++) G[p[j]][i] += _G[j][k]*Cp[k];
	    }
	}
        if(L!=p[0])for(i=0;i<*n;i++)	     /* swap lines G[L] <-> G[p[0]] */
	{   GL_Long A=G[L][i]; G[L][i]=G[p[0]][i]; G[p[0]][i]=A; 
	}
	for(i=0;i<L;i++)	 /* make upper diag minimal nonneg. */
	{   GL_Long R=NF[i][C]/NF[L][C];
	    if((NF[i][C]-R*NF[L][C])<0) R-=1;
	    NF[i][C]-=R*NF[L][C]; for(j=0;j<*n;j++)G[i][j]-=R*G[L][j];
	}
     }
     while(++C<*nv)for(i=0;i<*n;i++)for(j=0;j<*n;j++)NF[i][C]+=G[i][j]*X[j][C];
     for(i=0;i<*n;i++)for(j=0;j<*nv;j++) { 
#ifdef	SHOW_NFX_LIMIT
	g=NF[i][j]; if(g<0) g=-g; if(g>NFX_Limit) { printf(
	    "NFX_Limit in GL -> %lld !!\n",(long long) g); return 0; } else 
#endif
	X[i][j]=NF[i][j]; }
     return 1;
}
/*      =============================================================       */

void TEST_rVM_VPM(int *d,int *v,int *f, Long X[POLY_Dmax][VERT_Nmax],
	    	Long x[VERT_Nmax][VERT_Nmax])
{    int i,j,err=0; for(i=0;i<*v;i++)
     {	for(j=0;j<*d;j++) if(abs(X[j][i])>X_Limit) err=X[j][i];
	for(j=0;j<*f;j++) if(abs(x[j][i])>VPM_Limit) err=x[j][i]; 
     }	if(err)
     {	printf("TEST_VM_VPM: limits exceeded %d\n",err);
	printf("%d %d VM[%d][%d]:\n",*v,*d,*d,*v);
	for(j=0;j<*d;j++)
	{   for(i=0;i<*v;i++)printf("%3d ",(int) X[j][i]);puts("");
	}   puts("");
	printf("VPM[%d][%d]:\n",*f,*v);
	for(j=0;j<*f;j++)
	{   for(i=0;i<*v;i++)printf("%3d ",(int) x[j][i]);puts("");
	}   puts("");
	exit(0);
     }
}

int  Init_rVM_VPM(PolyPointList *_P,VertexNumList *_V,EqList *_F,/* in */
	    	int *d,int *v,int *f, Long X[POLY_Dmax][VERT_Nmax],  /* out */
	    	Long x[VERT_Nmax][VERT_Nmax])		/* return reflexive */
{    int i,j, ref=1; 
     *v=_V->nv; *f=_F->ne; *d=_P->n;
     for(j=0;j<_F->ne;j++)                            	     /* compute VPM */
     {
	if(_F->e[j].c!=1) ref=0; 
	for(i=0;i<_V->nv;i++)
        x[j][i]=Eval_Eq_on_V(&_F->e[j],_P->x[_V->v[i]],_P->n);
     }
     for(i=0;i<_V->nv;i++)
     {  Long *pv=_P->x[_V->v[i]];
	for(j=0;j<_P->n;j++) X[j][i]=pv[j];
     }
     TEST_rVM_VPM(d,v,f,X,x);
     return ref;
}

void New_pNF_Order(int *v,int *f,PERM *CL,int *ns,Long VPM_NF[][VERT_Nmax])
{    int i, j, pi[VERT_Nmax], c[VERT_Nmax]; 
     Long maxP[VERT_Nmax], sumP[VERT_Nmax];
     for(i=0;i<*v;i++)
     {	pi[i]=i; maxP[i]=sumP[i]=0; for(j=0;j<*f;j++)
	{   sumP[i]+=VPM_NF[j][i];
	    if(VPM_NF[j][i]>maxP[i])maxP[i]=VPM_NF[j][i];
	}
     }
     for(i=0;i<*v-1;i++)
     {	int n=i; for(j=i+1;j<*v;j++) 
        {   if(maxP[j]<maxP[n]) n=j; else 
	    if(maxP[j]==maxP[n]) if(sumP[j]<sumP[n]) n=j;
	}
        if(n!=i)	
     	{   Long aP=maxP[i]; int a=pi[i]; 
	    maxP[i]=maxP[n]; maxP[n]=aP; pi[i]=pi[n]; pi[n]=a;
	    aP=sumP[i]; sumP[i]=sumP[n]; sumP[n]=aP; 
	}
     }
     for(i=0;i<*ns;i++) 
     {	int *C=CL[i].C; for(j=0;j<*v;j++) c[j]=C[pi[j]]; 
	for(j=0;j<*v;j++) C[j]=c[j];
     }
}

void Print_vNF(int *v, int *f, Long VPM[][VERT_Nmax], Long VPM_NF[][VERT_Nmax])
{    int i,j; printf("\nVPM NF (v=%d f=%d):\n",*v,*f); fflush(stdout);
     for(i=0;i<*f;i++)
     {  for(j=0;j<*v;j++)printf("%3d",(int)VPM[i][j]);printf(" =>");
	fflush(stdout);
        for(j=0;j<*v;j++)printf("%3d",(int)VPM_NF[i][j]);puts(""); 
	fflush(stdout);
     }	puts("");
}

void Eval_Poly_NF(int *d,int *v,int *f, Long VM[POLY_Dmax][VERT_Nmax],
		Long VPM[VERT_Nmax][VERT_Nmax],			      /* in */
		Long pNF[POLY_Dmax][VERT_Nmax],int t)		     /* out */
{    PERM *CL=(PERM *) malloc((SYM_Nmax+1) * sizeof(PERM)); 
     Long VPM_NF[VERT_Nmax][VERT_Nmax]; int ns; assert(CL!=NULL);
     Make_VPM_NF(v,f,VPM,CL,&ns,VPM_NF);	if(t)Print_vNF(v,f,VPM,VPM_NF);
     New_pNF_Order(v,f,CL,&ns,VPM_NF);
     Aux_pNF_from_vNF(CL,&ns,v,d,VM,pNF,&t);	free(CL);
#ifdef WARN_BIG_NS
#ifdef SHOW_BIG_NS
     if(SHOW_BIG_NS<=ns) {int i,j;    printf("ns=%d VM:\n",ns);fflush(stdout);
	for(i=0;i<*d;i++){for(j=0;j<*v;j++)printf("%2d ",(int)VM[i][j]);
	puts("");}	printf("ns=%d VPM:\n",ns);fflush(stdout);
	for(i=0;i<*f;i++){for(j=0;j<*v;j++)printf("%2d ",(int)VPM[i][j]);
	puts("");}	printf("ns=%d VPM_NF:\n",ns);fflush(stdout);
	for(i=0;i<*f;i++){for(j=0;j<*v;j++)printf("%2d ",(int)VPM_NF[i][j]);
	puts("");}	printf("ns=%d pNF:\n",ns);fflush(stdout);
	for(i=0;i<*d;i++){for(j=0;j<*v;j++)printf("%2d ",(int)pNF[i][j]);
	puts("");}	exit(0);}
#endif
#endif
}

/*   ========			tedious details of NFs		  =======   */
/*   Make_NF();     make NormalForm of VertexPairingMatrices       ======
 *
 *   To bring the VPM to normal form, NF=lexicographic if reading line by line
 *   we need permutations Cp and Lp of columns and lines: Make Cp's respecting
 *   rest symmetry to get maximal lines and remember them and their rest sym.
 *   1. Start with last permutation and append different refinements or throw
 *      everything below away if you find a `better' NF; 
 *   2. Remember permutation and rest symmetry if equal; replace by last one 
 *      if the `next' line is not good.
 *   In each step, i.e. after finding n lines of NF, their {Cp,Lp}'s and sym.
 *   s[i]=l, s[j]=i for i<j<=l  iff  {i,...,l} equiv;  else s[i]=i;
 */
void Aux_vNF_Line(int l,vNF *_X,Long x[][VERT_Nmax], PERM *CL,int *S,int *_ns)
{    int n=(*_ns), cf=0;	/*  cf=CompareFlag (ref. exists & o.k.      */
     Long *y, r[VERT_Nmax];	/*  r=ReferenceLine; y->X[line]		    */
     while(n--)      /*  go over CL (n from  *_ns-1  to  0), ns_* changes!  */
     {	PERM nP[VERT_Nmax];	        
	int c=0, L=l-1, np=0, *C, ccf=cf;	/*  ccf=column compare flag */
	*nP=CL[n];
	while(++L<_X->nf)			/*  init nP (from 1st col.) */
	{   int j=0; C=nP[np].C; y=x[nP[np].L[L]];
	    while(++j<=*S) if(y[C[c]]<y[C[j]]) swap(&C[c],&C[j]);
	    if(ccf)
	    {   Long d=y[*C]-*r;
		if(d<0) ;					/* BAD line */
		else if(d)				     /* BETTER line */
		{   *r=y[*C]; cf=0; *nP=nP[np]; nP[np=1]=CL[n]; *_ns=n+1;
		    swap(&(nP->L[l]),&(nP->L[L]));
		}
		else					      /* EQUAL line */
		{   swap(&(nP[np].L[l]),&(nP[np].L[L])); nP[++np]=CL[n];
		}
	    }
	    else 						/* NEW line */
	    {	*r=y[*C]; swap(&(nP[np].L[l]),&(nP[np].L[L]));
		nP[++np]=CL[n]; ccf=1;
	    }
	}
	while(++c<_X->nv)			       /* check/complete nP */
	{   int s=S[c]; L=np; ccf=cf;
	    if(s<c) s=S[s];	
	    while(L--)
	    {	int j=c; C=nP[L].C; y=x[nP[L].L[l]];
		while(++j<=s) if(y[C[c]]<y[C[j]]) swap(&C[c],&C[j]);
		if(ccf)
		{   Long d=y[C[c]]-r[c];
		    if(d<0) {if(--np>L) nP[L]=nP[np];}		/* BAD line */
		    else if(d) 				     /* BETTER line */
		    {	r[c]=y[C[c]]; cf=0; np=L+1; *_ns=n+1;
		    }	/* else	; */			      /* EQUAL line */
		}
		else { r[c]=y[C[c]]; ccf=1; }
	    }
	}
	cf=1;
	if(--(*_ns) > n) CL[n]=CL[*_ns]; 		/*  write nP to CL  */
	if(SYM_Nmax < (cf=(*_ns+np)))
	{   printf("Need SYM_Nmax > %d !!\n",cf);exit(0);
	}
	for(L=0;L<np;L++) CL[(*_ns)++]=nP[L];
     }
     y=x[CL->L[l]];					       /* compute S */
     {	int c=0, *C=CL->C;
	while(c<_X->nv)	
	{   int s=S[c]+1; S[c]=c; while(++c<s)
	    {   if(y[C[c]]==y[C[c-1]]) ++S[ S[c]=S[c-1] ]; 
	        else S[c]=c;
	    }
	}
     }
}
void Aux_vNF_Init(vNF *_X, Long x[][VERT_Nmax], PERM *CL, int *S, int *_ns)
{    int i, j, nn; Long *b, *y;
     PERM P, *q, *p;		       /* b=x[nb] -> best;  y=x[nn] -> next */
     for(i=0;i<_X->nf;i++) P.L[i]=i;
     for(j=0;j<_X->nv;j++) P.C[j]=j; /* init P */
     q=CL; *q=P; b=*x;          /* P=CL[ns-1] StartPerm; maximize 0-th line */
     for(j=1;j<_X->nv;j++)if(b[q->C[0]]<b[q->C[j]])swap(&q->C[0],&q->C[j]);
     for(i=1;i<_X->nv;i++) 
     {  for(j=i+1;j<_X->nv;j++) if(b[q->C[i]]<b[q->C[j]]) 
        swap(&q->C[i],&q->C[j]);
     }
     for(nn=1;nn<_X->nf;nn++)			     /* maximize nn-th line */
     {  Long d; p=&CL[*_ns]; *p=P; y=x[nn]; /* nb=*q=*b=best, nn=*p=*y=next */
        {   int m=0; for(j=1;j<_X->nv;j++) if(y[p->C[m]]<y[p->C[j]]) m=j;
            if(m) swap(&p->C[0],&p->C[m]);
        }
        if((d=y[p->C[0]]-b[q->C[0]]) < 0) continue;   /* d<0 => forget this */
        for(i=1;i<_X->nv;i++) 
        {   int m=i; for(j=i+1;j<_X->nv;j++) if(y[p->C[m]]<y[p->C[j]]) m=j; 
            if(m>i) swap(&p->C[i],&p->C[m]);
            if(d==0) if((d=y[p->C[i]]-b[q->C[i]]) <0) break;
        }
        if(d<0) continue;
        swap(&p->L[0],&p->L[nn]);		 /* p->L[nn]=0; p->L[0]=nn; */ 
        if(d==0) (*_ns)++; 
        else {*q=*p; *_ns=1; b=y;}                    /* d>0 => forget prev */
     }
     y=x[CL->L[0]]; S[0]=0; for(i=1;i<_X->nv;i++)	       /* compute S */
     if(y[CL->C[i]]==y[CL->C[i-1]]) ++S[ S[i]=S[i-1] ]; else S[i]=i;
}


int  Aux_XltY_Poly_NF(Long X[][VERT_Nmax],Long Y[][VERT_Nmax], int *n,int *nv)
{    int i, j; Long d;					  /* return "X < Y" */
     for(i=0;i<*n;i++)for(j=0;j<*nv;j++) if(d=X[i][j]-Y[i][j]) 
     {	if(d<0) return 1; else return 0;
     }
     return 0;
}
void TEST_pNF(int* C,Long V[][VERT_Nmax],Long X[][VERT_Nmax],
	      int* n,int* nv,int* try_)
{    int i,j; printf("Poly NF try[%d]:   C=",*try_);
     for(i=0;i<*nv;i++)printf("%d",C[i]);puts("");
     for(i=0;i<*n;i++)
     {	for(j=0;j<*nv;j++)printf("%6d",(int) V[i][j]); printf(" =>");
	for(j=0;j<*nv;j++)printf("%3d",(int) X[i][j]); puts("");
     }
}

void Aux_Make_Triang(PERM *CL,int ns,Long V[][VERT_Nmax],int*n,int*nv,int *t)
{    int i, j, s, x=0, g=0, ps=1;		   /* x :: make X :: if X>Y */
     Long X[POLY_Dmax][VERT_Nmax], Y[POLY_Dmax][VERT_Nmax];
     for(i=0;i<*n;i++) for(j=0;j<*nv;j++) X[i][j]=V[i][CL->C[j]];
     if(!Aux_Make_Poly_NF(X,n,nv)) exit(0); 		  /* t>0: print NFs */
							  /*  -1: calc CL.s */
     if(*t) { if(*t>0) TEST_pNF(CL->C,V,X,n,nv,&g); else 
              { CL->s=1; if(*t+1){puts("t<-1 in Aux_Make_Triang");exit(0);} }
            } for(s=1;s<ns;s++)CL[s].s=0;

     for(s=1;s<ns;s++)
     if(x)
     {	for(i=0;i<*n;i++) for(j=0;j<*nv;j++) X[i][j]=V[i][CL[s].C[j]];
     	if(!Aux_Make_Poly_NF(X,n,nv)) exit(0); 
	if(Aux_XltY_Poly_NF(X,Y,n,nv)) x=0;

	if(*t)
	{   if(*t>0) TEST_pNF(CL[s].C,V,X,n,nv,&s); 
	    if(x==0)
	    {	if(*t<0) { int k; for(k=g;k<s;k++) CL[k].s=0; CL[s].s=1;*t=-1;}
		g=s; ps=1; 
	    } 
	    else if(!Aux_XltY_Poly_NF(Y,X,n,nv))
		{ if(*t<0) {CL[s].s=1;(*t)--;} ps++;}
        }
     }
     else
     {	for(i=0;i<*n;i++) for(j=0;j<*nv;j++) Y[i][j]=V[i][CL[s].C[j]];
     	if(!Aux_Make_Poly_NF(Y,n,nv)) exit(0); 
	if(Aux_XltY_Poly_NF(Y,X,n,nv)) x=1;

	if(*t)
	{   if(*t>0) TEST_pNF(CL[s].C,V,Y,n,nv,&s); 
	    if(x==1)
	    {	if(*t<0) { int k; for(k=g;k<s;k++) CL[k].s=0; CL[s].s=1;*t=-1;}
		g=s; ps=1;
	    } 
	    else if(!Aux_XltY_Poly_NF(X,Y,n,nv))
		{ if(*t<0) {CL[s].s=1;(*t)--;} ps++;}
	}
     }
     if(*t>0)
     printf("\nPoly NF:  NormalForm=try[%d]  #Sym(VPM)=%d  #Sym(Poly)=%d\n",
	g,ns,ps);
     if(x) for(i=0;i<*n;i++)for(j=0;j<*nv;j++) V[i][j]=Y[i][j];
     else  for(i=0;i<*n;i++)for(j=0;j<*nv;j++) V[i][j]=X[i][j];
}
/*   ========		END of 	tedious details of NFs		  =======   *
 *
 *	Make_VPM_NF		uses	Aux_vNF_Init, Aux_vNF_Line
 *
 *	Aux_pNF_from_vNF	uses	Aux_Make_Triang
 */
void Make_VPM_NF(int *v, int *f, Long x[VERT_Nmax][VERT_Nmax],      /* in */
		PERM *CL,int *ns,Long VPM_NF[VERT_Nmax][VERT_Nmax])  /* out */
{    int i, j, S[VERT_Nmax]; int nsF=0, nsM=0; 		     /* make VPM NF */

     volatile vNF auX; vNF *_X= (vNF*) &auX;  _X->nv=*v;_X->nf=*f; /* x=VPM */
     *ns=1; Aux_vNF_Init(_X, x, CL, S, ns);             /* init = 1st line */
     for(i=1;i<_X->nf-1;i++){Aux_vNF_Line(i,_X,x,CL,S,ns);  /* lines of NF */
#ifdef	WARN_BIG_NS
	if((WARN_BIG_NS<=(*ns))||nsF){ nsF=1;/*printf("ns[%d]=%d\n",i,*ns);*/}
#endif
	if(*ns>nsM) nsM=*ns; }
     _X->ns=*ns; for(i=0;i<_X->nv;i++)                /* write VPM-NF to _X */
     {  for(j=0;j<_X->nf;j++) /* _X->x */ VPM_NF[j][i]=x[CL->L[j]][CL->C[i]];
     }
     if(nsF)printf("WARNing: ns_max=%d -> ns=%d\n",nsM,*ns);
}

void Aux_pNF_from_vNF(PERM *CL,int *ns,int *v,int *d,
		Long VM[POLY_Dmax][VERT_Nmax],			      /* in */
		Long pNF[POLY_Dmax][VERT_Nmax],int *t)		     /* out */
{    int i,j;
     for(i=0;i<*d;i++)for(j=0;j<*v;j++) pNF[i][j]=VM[i][j];
     Aux_Make_Triang(CL,*ns,pNF,d,v,t);
}

int  Make_Poly_NF(PolyPointList *_P, VertexNumList *_V, EqList *_F,
		Long pNF[POLY_Dmax][VERT_Nmax])		  /* 1 if reflexive */
{    int d, v, f;
     Long VM[POLY_Dmax][VERT_Nmax], VPM[VERT_Nmax][VERT_Nmax];
     int ref=Init_rVM_VPM(_P,_V,_F,&d,&v,&f,VM,VPM);
     Eval_Poly_NF(&d,&v,&f,VM,VPM,pNF,0); return ref;
}

void Poly_Sym(PolyPointList *_P, VertexNumList *_V, EqList *_F, int *sym_num,
	int V_perm[][VERT_Nmax])
{    Long pNF[POLY_Dmax][VERT_Nmax]; 
     Make_Poly_Sym_NF(_P,_V,_F,sym_num,V_perm,pNF,0);
}
int  PermChar(int n)
{    if(n<10) return '0'+n; else if(n<36) return 'A'+n-10; else 
     {puts("Printing permutations only for #Vert<=36 !!");exit(0);} return 0;
}
int  Make_Poly_Sym_NF(PolyPointList *_P, VertexNumList *_V, EqList *_F, 
		      int *SymNum, int V_perm[][VERT_Nmax], 
		      Long NF[POLY_Dmax][VERT_Nmax], int traced)
{    int i, j, ns, t=-1, *d=&_P->n, *v=&_V->nv, *f=&_F->ne, *C; 
     PERM *CL = (PERM *) malloc ( sizeof(PERM) *(SYM_Nmax+1));
     Long VM[POLY_Dmax][VERT_Nmax], VPM[VERT_Nmax][VERT_Nmax];
     Long VPM_NF[VERT_Nmax][VERT_Nmax];

     Init_rVM_VPM(_P,_V,_F,d,v,f,VM,VPM);
     if (traced) Eval_Poly_NF(&_P->n,&_V->nv,&_F->ne,VM,VPM,NF,1);
     Make_VPM_NF(v,f,VPM,CL,&ns,VPM_NF);
     New_pNF_Order(v,f,CL,&ns,VPM_NF);
     Aux_pNF_from_vNF(CL,&ns,v,d,VM,NF,&t);
     *SymNum=-t;i=0; while(0==CL[i].s) i++; C=CL[i].C;
     for(t=0;i<ns;i++) if(CL[i].s)		/* inv Perm: C[c0[i]]=C[i] */
       {for(j=0;j<*v;j++) V_perm[t][C[j]]=CL[i].C[j]; t++;}  
     if(t!=*SymNum) { puts("Error in Poly_Sym!!"); exit(0);} 
     if(traced){
       printf("\nV_perm made by Poly_Sym (order refers to VertNumList):\n");
       for(i=0;i<*SymNum;i++){
	 for(j=0;j<_V->nv;j++) 
	 printf("%c",PermChar(V_perm[i][j])); 
	 puts("");}} free(CL);
     return ns;
}
void Aux_NF_Coord(PolyPointList *_P, Long VM[POLY_Dmax][VERT_Nmax], int *C,
		  	int *n, int *np, int *v)
{    SL_Long S[POLY_Dmax][POLY_Dmax], X[POLY_Dmax]; 
     Long V[POLY_Dmax][VERT_Nmax]; int i, j;
     for(i=0;i<*n;i++) for(j=0;j<*v;j++) V[i][j]=VM[i][C[j]];
     if(!SL2Z_Make_Poly_NF(V,n,v,S)) exit(0);
     for(j=0;j<*np;j++) 
     {	for(i=0;i<*n;i++) 
	{   int k=*n; X[i]=0; while(k--) X[i]+=_P->x[j][k]*S[i][k];
	}
	for(i=0;i<*n;i++) _P->x[j][i]=X[i];
     }
}

void NF_Coordinates(PolyPointList *_P, VertexNumList *_V, EqList *_F)
					     /* needs converted EqList !! */
{    PERM CL[SYM_Nmax+1]; int ns;
     Long VM[POLY_Dmax][VERT_Nmax],  VPM[VERT_Nmax][VERT_Nmax];
     Init_rVM_VPM(_P,_V,_F,&_P->n,&_V->nv,&_F->ne,VM,VPM);	/* make VPM */
     {	Long VPM_NF[VERT_Nmax][VERT_Nmax]; 
	Make_VPM_NF(&_V->nv,&_F->ne,VPM,CL,&ns,VPM_NF);		/* get PERM */
     	New_pNF_Order(&_V->nv,&_F->ne,CL,&ns,VPM_NF);	    /* improve PERM */
     }
     Aux_NF_Coord(_P,VM,CL->C,&_P->n,&_P->np,&_V->nv);	      /* improve _P */
     {	int f=_F->ne; VertexNumList V;		     /* EqList in new basis */
    	if(!IP_Check(_P,&V,_F)){puts("IP=0 in NF_Coords"); exit(0);}
	if((V.nv!=_V->nv)||(f!=_F->ne)) {puts("Error in NF_Coords"); exit(0);}
     }
}
int  Improve_Coords(PolyPointList *_P,VertexNumList *_V)
{    SL_Long S[POLY_Dmax][POLY_Dmax], X[POLY_Dmax]; 
     Long V[POLY_Dmax][VERT_Nmax]; int i, j;
     for(i=0;i<_P->n;i++) for(j=0;j<_V->nv;j++) V[i][j]=_P->x[_V->v[j]][i];
     if(!SL2Z_Make_Poly_NF(V,&(_P->n),&(_V->nv),S)) return 0;
     for(j=0;j<_P->np;j++) 
     {	for(i=0;i<_P->n;i++) 
	{   int k=_P->n; X[i]=0; 
	    while(k--) X[i] += (long long) _P->x[j][k] * S[i][k];
	}
	for(i=0;i<_P->n;i++) _P->x[j][i]=X[i];
     }
	return 1;
}

/*  =================	SL(2,Z) - Version of Trian_NF	 =================  */
void SL_swap(SL_Long *X, SL_Long *Y)
{    SL_Long A=*Y; *Y=*X; *X=A; 
}
SL_Long SL_Egcd(SL_Long A0, SL_Long A1, SL_Long *Vout0, SL_Long *Vout1)  
{    register SL_Long V0=A0, V1=A1, A2, X0=1, X1=0, X2=0;
     while(A2 = A0 % A1) { X2=X0-X1*(A0/A1); A0=A1; A1=A2; X0=X1; X1=X2; }
     *Vout0=X1, *Vout1=(A1-(V0) * X1)/ (V1); return A1;
}
/*   S * X = UpperTrian;  T * S = 1     (a b)   x = g           (d -b)(a b)=1
 *   g=EGCD(x,y,&a,&b); ax+by=g =>      (c d)   y   0           (-c a)(c d)=1
 *   c=-y/g, d=x/g => det(abcd)=1
 */

int  SL2Z_Make_Poly_NF(Long X[][VERT_Nmax], int *n, int *nv, 
		       SL_Long S[POLY_Dmax][POLY_Dmax])
{    SL_Long NF[POLY_Dmax][VERT_Nmax], a, b, g;
     int i, j, C=-1, L; 
     for(i=0;i<*n;i++)for(j=0;j<*n;j++)S[i][j]=(i==j);		  /* init S */
     for(i=0;i<*n;i++)for(j=0;j<*nv;j++)NF[i][j]=0;		
     for(L=0;L<*n-1;L++)
     {  int N=0;
        while(!N)                /* find column C with N>0 non-zero entries */
        {   ++C; for(i=0;i<*n;i++) 
	    {	for(j=0;j<*n;j++) NF[i][C]+=S[i][j]*X[j][C];
	    }
            if(NF[i=L][C]) N++; 
	    while(++i<*n) if(NF[i][C])
	    {	N++;					 /* make NF[i][C]=0 */
		if(NF[L][C])
		{   SL_Long A; 
		    g=SL_Egcd(NF[L][C],NF[i][C],&a,&b);
		    for(j=0;j<*n;j++)			/* c=-N_iC/g */
		    {	A=a*S[L][j]+b*S[i][j];		/* d= N_LC/g */
			S[i][j]=(NF[L][C]/g)*S[i][j]-(NF[i][C]/g)*S[L][j];
			S[L][j]=A;
		    }
		    NF[L][C]=g; NF[i][C]=0;
		}
		else
		{   SL_swap(&NF[L][C],&NF[i][C]);
		    for(j=0;j<*n;j++)SL_swap(&S[L][j],&S[i][j]);
		}
	    }
	    if(NF[L][C]<0) 
	    {	NF[L][C]*=-1;for(j=0;j<*n;j++)S[L][j]*=-1;	    /* sign */
	    }
	    if(N) for(i=0;i<L;i++)	 /* make upper diag minimal nonneg. */
	    {	SL_Long R=NF[i][C]/NF[L][C];
		if((NF[i][C]-R*NF[L][C])<0) R-=1;
		NF[i][C]-=R*NF[L][C]; for(j=0;j<*n;j++)S[i][j]-=R*S[L][j];
	    }
	}
     }
     while(++C<*nv)
     {	for(i=0;i<*n;i++) for(j=0;j<*n;j++) NF[i][C]+=S[i][j]*X[j][C];
	if(L)if(NF[L][C])
	{   if(NF[L][C]<0)
	    {	NF[*n-1][C]*=-1; for(j=0;j<*n;j++) S[L][j]*=-1;
	    }
	    for(i=0;i<L;i++)		 /* make upper diag minimal nonneg. */
	    {	SL_Long R=NF[i][C]/NF[L][C];
		if((NF[i][C]-R*NF[L][C])<0) R-=1;
		NF[i][C]-=R*NF[L][C]; for(j=0;j<*n;j++)S[i][j]-=R*S[L][j];
	    }
	    L=0;
	}
     }
     for(i=0;i<*n;i++)for(j=0;j<*nv;j++)
     if( labs(X[i][j]=NF[i][j]) > NFX_Limit)
     {	printf("NFX_Limit in SL: I need %ld !!\n",labs(X[i][j]));return 0;
     }
     return 1;
}
/*      =============================================================       */


/*  =================	weights, fibrations and quotients   ==============  */
Long GxP(GL_Long *Gi,Long *V,int *d)
{     Long x=0; int j; for(j=0;j<*d;j++) x+=Gi[j]*V[j]; return x;
}
void G_2_BxG(GL_Long **G,GL_Long **B,int *d,int *L)		/* G -> B.G */
{    GL_Long W[POLY_Dmax]; int l,c; for(c=0;c<*d;c++)
     {  for(l=*L;l<*d;l++)
	{   int j; W[l]=0; for(j=*L;j<*d;j++) W[l]+=B[l-*L][j-*L]*G[j][c];
	}   for(l=*L;l<*d;l++) G[l][c]=W[l];
     }						/* TEST_GLZmatrix(G,*d); */
}
#define	TEST
#undef  TEST_OUT
void TEST_GLZmatrix(GL_Long *G[POLY_Dmax], int d)
{	int x,y; GL_Long Ginv[POLY_Dmax][POLY_Dmax];
	Long X[POLY_Dmax][VERT_Nmax]; 
	for(x=0;x<d;x++)for(y=0;y<d;y++)X[x][y]=G[x][y];
	GLZ_Make_Trian_NF(X,&d,&d,Ginv);
	for(x=0;x<d;x++)for(y=0;y<d;y++)assert(X[x][y]==(x==y));
}
void INV_GLZmatrix(GL_Long G[][POLY_Dmax], int *d,GL_Long Ginv[][POLY_Dmax])
{	int x,y;
	Long X[POLY_Dmax][VERT_Nmax]; 
	for(x=0;x<*d;x++)for(y=0;y<*d;y++)X[x][y]=G[x][y];
	GLZ_Make_Trian_NF(X,d,d,Ginv);
	for(x=0;x<*d;x++)for(y=0;y<*d;y++)if(X[x][y]!=(x==y)) goto NoGLZ;
        return;
NoGLZ:	puts("No GLZ-Matrix in INV_GLZmatrix:"); for(x=0;x<*d;x++)
	{for(y=0;y<*d;y++) printf(" %5d",G[x][y]);puts("");} exit(0);
}
GL_Long GL_V_to_GLZ(GL_Long *V, GL_Long *G[POLY_Dmax], int d)
{    int i, j, p=0, z=0, P[POLY_Dmax], Z[POLY_Dmax]; GL_Long g, W[POLY_Dmax];
     for(i=0;i<d;i++) if(V[i]) {W[p]=V[(P[p]=i)];p++;} else Z[z++]=i; 
	assert(z+p==d); 
     if(p>1) 
     {	g=GL_W_to_GLZ(W,p,G); if(g<0) for(i=0;i<p;i++) G[0][i]*= -1; 
	i=p; while(i--) 
	{   int x=P[i]; for(j=p;j<d;j++)G[j][x]=0; j=p;
	    while(j--) G[j][x]=G[j][i]; while(0<j--)G[j][x]=0;
	}   for(i=0;i<z;i++) for(j=0;j<d;j++) G[j][Z[i]] = (d-j==i+1);
     }
     else 
     {	for(j=0;j<d;j++)for(i=0;i<d;i++)G[i][j]=(i==j); assert(p); if(P[0])
	{G[P[0]][P[0]]=G[0][0]=0; G[0][P[0]]=G[P[0]][0]=(V[P[0]]>0) ? 1 : -1;}
	else if(*V<0) G[0][0]=-1; g=V[P[0]];
     }	if(g<0) g=-g;
#ifdef	TEST_OUT
	for(i=0;i<d;i++){printf("G[%d]= ",i);for(j=0;j<d;j++)
	printf("%2d ",G[i][j]);printf("    V=%d\n",V[i]);}
	puts("testing GLZ in GL_V_to_GLZ"); fflush(0);
#endif
#ifdef	TEST
	{int x,y; TEST_GLZmatrix(G,d);
	for(x=0;x<d;x++){Long Y=0; for(y=0;y<d;y++) Y+=G[x][y]*V[y];
	   if(x) assert(Y==0); else assert(Y>0);}}
#endif
     return g;
}
int  TriMat_to_Weight(GL_Long T[][POLY_Dmax], int *p,int r,int *s,
	int *nw, Long W[][VERT_Nmax], int *Wmax)
{    int i,j; Long g, a, b, x[POLY_Dmax+1], *X=W[*nw]; 
     if(0<=(b=T[r][r-1])) return 0;
     g=Fgcd(a=T[r-1][r-1],-b);x[r-1]=-b/g;x[r]=a/g;
     for(j=r-2;0<=j;j--)
     {	a=T[j][j]; b=0; for(i=j+1;i<=r;i++)b-=x[i]*T[i][j];
	if(b<=0) return 0; else g=Fgcd(a,b); x[j]=b/g; 
	a/=g; if(a>1) for(i=j+1;i<=r;i++) x[i]*=a;
     }	assert((*nw)++ < *Wmax);
     for(i=0;i<*p;i++)X[i]=0; for(i=0;i<=r;i++)X[s[i]]=x[i]; return 1;
#ifdef	TEST_OUT
	for(i=0;i<r;i++){printf("r=%d nw=%d:  ",r,*nw);
	    for(j=0;j<=r;j++)printf(" %2d",T[j][i]);puts("");}
	for(i=0;i<=r;i++)printf(" %2d",x[i]);printf("  =W  p=%d  S=",*p);
	for(i=0;i<=r;i++)printf(" %2d",s[i]);puts("");
#endif
}
Long XmY_vecdiff(Long *X, Long*Y, int n)
{    Long d; while(n--) if(d=X[n]-Y[n]) return d; return 0;
}
void Remove_Identical_Points(PolyPointList *P)
{    int i,p,s,r=0; for(p=0;p<P->np;p++)
     {	for(s=0;s<r;s++) if(0==XmY_vecdiff(P->x[p],P->x[s],P->n)) break;
	if(s==r) { if(r<p)for(i=0;i<P->n;i++)P->x[r][i]=P->x[p][i]; r++;}
     }	P->np=r; 
}
int  PM_to_GLZ_for_UTriang(Long M[][VERT_Nmax],int *d,int *v,/* return rank */
                       GL_Long G[POLY_Dmax][POLY_Dmax])	  /* allows rank<*d */
{    int i,j,k,r=0; GL_Long B[POLY_Dmax][POLY_Dmax],*b[POLY_Dmax],
	*g[POLY_Dmax]; for(i=0;i<*d;i++) {b[i]=B[i]; g[i]=G[i];}
     for(i=0;i<*d;i++) for(j=0;j<*d;j++) G[i][j]=(i==j); for(i=0;i<*v;i++)
     {	GL_Long V[POLY_Dmax]; int nz=0; for(j=r;j<*d;j++) 
	{   GL_Long x=0; for(k=0;k<*d;k++)x+=G[j][k]*M[k][i]; if(V[j]=x)nz=1;}
	if(nz) {GL_V_to_GLZ(&V[r],b,*d-r); G_2_BxG(g,b,d,&r); r++;}
     }	return r;
}
typedef	Long PoMat[VERT_Nmax][POLY_Dmax];
typedef	Long VMat[POLY_Dmax][VERT_Nmax];
void Print2_PM(Long PM[][POLY_Dmax],int d,int p)
{    int i,j; for(i=0;i<d;i++)for(j=0;j<p;j++)
	printf("%2d%c",PM[j][i],(j==p-1) ? '\n' : ' ');
}
void Print2_VM(VMat VM,int d,int p)
{    int i,j; for(i=0;i<d;i++)for(j=0;j<p;j++)
	printf("%2d%c",VM[i][j],(j==p-1) ? '\n' : ' ');
}
int  InvariantSubspace(PolyPointList *P,VertexNumList *V,EqList *E)
{    int i,v, r=0, p=0, pri, EVsn, sn, V_perm[SYM_Nmax][VERT_Nmax];
     Long NF[POLY_Dmax][VERT_Nmax]; VMat Inv;
     EVsn=Make_Poly_Sym_NF(P,V,E,&sn,V_perm,NF,0); for(v=0;v<V->nv;v++) 
     {	Long X[POLY_Dmax], g=0; for(i=0;i<P->n;i++)
	{   int s; X[i]=0; for(s=0;s<sn;s++)X[i]+=P->x[V->v[V_perm[s][v]]][i];
	    if(X[i]) g = g ? NNgcd(g,X[i]) : X[i];
	}   if(g>0)
	{   for(i=0;i<P->n;i++) {assert(0==(X[i]%g)); Inv[i][p]=X[i]/g;} p++;
	}
     }	pri=p; if(p>V->nv){printf("p=%d v=%d\n",p,V->nv);exit(0);}
     if(pri) printf("%d %d  #Sym=%d (<=%d)  ",P->n,V->nv,sn,EVsn);	if(p)
     {	GL_Long G[POLY_Dmax][POLY_Dmax],B[POLY_Dmax][POLY_Dmax];
	r=PM_to_GLZ_for_UTriang(Inv,&P->n,&p,G); if(pri)
	{   VMat VM; int j; for(j=0;j<p;j++) for(i=0;i<P->n;i++) {VM[i][j]=0;
	    	for(v=0;v<P->n;v++) VM[i][j] += G[i][v]*Inv[v][j];
	    	if(i>=r)assert(VM[i][j]==0);                    }
	    printf("InvSubspace: dim=%d <(",r); 
	    INV_GLZmatrix(G,&P->n,B); for(i=0;i<r;i++) for(v=0;v<P->n;v++)
	    printf("%d%s",B[v][i],(v<P->n-1) ? "," : ((i+1==r) ? "":"),("));
	    printf(")>\n"); 
	}
     }	else if(pri) printf("symmetric\n");
     if(pri){for(v=0;v<V->nv;v++)for(i=0;i<P->n;i++)Inv[i][v]=P->x[V->v[v]][i];
     	Print2_VM(Inv,P->n,V->nv);} return r;
}
void Einstein_Metric(CWS *CW,PolyPointList *P,VertexNumList *V,EqList *E)
{    int i,j,r,R=4, tot=0, sym=0, sum=0; Long S, PM[VERT_Nmax][VERT_Nmax];
     PolyPointList *A = (PolyPointList *) malloc(sizeof(PolyPointList));
     VertexNumList v; for(i=0;i<VERT_Nmax;i++) v.v[i]=i;
     while(Read_CWS_PP(CW,P))
     {	tot++; assert(Ref_Check(P,V,E)); Sort_VL(V);Make_VEPM(P,V,E,PM); 
	A->np=0; A->n=P->n; Complete_Poly(PM,E,V->nv,A);
	S=0; 
	for(i=0;i<P->n;i++)
	{   for(j=0;j<A->np;j++) S+=A->x[j][i]; if(S) break;
	}   if(S) continue;
	for(r=2;r<=R;r++)
	{   v.nv=V->nv; for(i=0;i<E->ne;i++) E->e[i].c=r; for(i=0;i<v.nv;i++)
	    for(j=0;j<A->n;j++)A->x[i][j]=r*P->x[V->v[i]][j];
/*	    for(i=0;i<v.nv;i++)for(j=0;j<E->ne;j++)
		assert(r*PM[j][i]==Eval_Eq_on_V(&(E->e[j]),A->x[i],P->n)); */
	    Make_VEPM(A,&v,E,PM); A->np=0; Complete_Poly(PM,E,V->nv,A); S=0;
	    for(i=0;i<A->n;i++)
	    {   for(j=0;j<A->np;j++) S+=A->x[j][i]; if(S) break;
	    }   
	    if(S!=0) break;
	}   
	if(S!=0) if(r>2) {Print_PPL(P,"nonzero");printf("r=%d\n",r);exit(0);} 
	if(S==0)
	{   int is; sum++; for(i=0;i<E->ne;i++) E->e[i].c=1;
	    is=InvariantSubspace(P,V,E); if(is==0) sym++;
	    /* Print_PPL(P,is ? "zerosum" : "symmetric"); */
	} 
     }	printf("#poly=%d #symmetric=%d #zerosum=%d\n",tot,sym,sum); exit(0);
}

typedef struct { Long W[FIB_Nmax][VERT_Nmax]; int nw, PS, ZS, nv, f[VERT_Nmax],
	r[VERT_Nmax],nf, 
	nz[FIB_Nmax], n0[FIB_Nmax], Z[VERT_Nmax][VERT_Nmax], M[VERT_Nmax]; 
	GL_Long G[VERT_Nmax][POLY_Dmax][POLY_Dmax]; PolyPointList *P;}	FibW;
void Check_New_Fiber(Long PM[][POLY_Dmax],int *p,int *d,int *nw,
	int *s, int r, FibW *F);
int  TriMat_to_WeightZ(GL_Long T[][POLY_Dmax], int *d,int *p,int r,int *s,
	int *nw, Long W[][VERT_Nmax], int *Wmax, FibW *F);
void IPS_Rec_New_Vertex(Long PM[][POLY_Dmax], int *p, int *d, int *nw, 
	Long W[][VERT_Nmax], int *Wmax, GL_Long ***G, 
	GL_Long *GI[POLY_Dmax][POLY_Dmax],
	GL_Long **GN, GL_Long T[][POLY_Dmax], int *s,int r, FibW *FW,int *CD)
{    int i,j,k, *n=&s[r]; GL_Long *X=T[r];    /* printf("called r=%d\n",r); */
     for(*n=s[r-1]+1;*n<*p;(*n)++)
     {	Long *P=PM[*n]; for(i=0;i<*d;i++)
	{   X[i]=0; for(j=0;j<*d;j++) X[i]+=G[r-1][i][j]*P[j];
	}   for(j=r;j<*d;j++) if(X[j]) break;
#ifdef	TEST_OUT
	printf("X=T[r=%d]:",r);for(i=0;i<*d;i++)printf(" %d",X[i]);
	printf(" j=%d   s=",j);for(i=0;i<=r;i++)printf(" %d",s[i]);puts("");
#endif
	if(j<*d) 
	{   X[r]=GL_V_to_GLZ(&X[r],GN,*d-r); for(i=r+1;i<*d;i++) X[i]=0;
	    for(i=r;i<*d;i++) for(j=0;j<*d;j++) { G[r][i][j]=0;
		for(k=0;k<*d-r;k++)G[r][i][j]+=GN[i-r][k]*G[r-1][r+k][j];}
#ifdef TEST
	TEST_GLZmatrix(G[r],*d);
	for(i=0;i<*d;i++){Long Z=0; for(j=0;j<*d;j++) Z+= G[r][i][j]*P[j];
	assert(Z==X[i]);} 
#endif
	    IPS_Rec_New_Vertex(PM,p,d,nw,W,Wmax,G,GI,GN,T,s,r+1,FW,CD);
	}
	else if(*CD==0) TriMat_to_WeightZ(T,d,p,r,s,nw,W,Wmax,FW);
	else if((*d-r<=*CD)&&(*d>r)&&(r>1))
	if(TriMat_to_WeightZ(T,d,p,r,s,nw,W,Wmax,FW))
	    Check_New_Fiber(PM,p,d,nw,s,r,FW);
     }					    /* printf("finished r=%d\n",r); */
}
int  Fiber_Ref_Check(Long PM[][POLY_Dmax], int *d, int *p, int *v,
	GL_Long G[POLY_Dmax][POLY_Dmax], GL_Long Ginv[][POLY_Dmax],
	Long X[VERT_Nmax][VERT_Nmax], PolyPointList *A, int r)
{    int i,j; VertexNumList V; EqList E; 
#ifdef	CHECK_Nref_FIRST
     int l,c=0; for(i=0;i<*p;i++)		
     {	for(l=r;l<*d;l++) if(GxP(G[l],PM[i],d)) break; if(l==*d)
	{   for(l=0;l<r;l++) A->x[c][l]=GxP(G[l],PM[i],d); c++;
	}   
     }  A->np=c; A->n=r; if(!Ref_Check(A,&V,&E)) return 0; /* only necessary */
#endif	
     A->np=*v; A->n=*d; for(i=0;i<*v;i++) for(j=0;j<*d;j++)
	A->x[i][j]=GxP(G[j],PM[i],d); /* reflexivity of projection */
     assert(Ref_Check(A,&V,&E)); EL_to_PPL(&E,A,d); A->n=r; 
     Remove_Identical_Points(A); return Ref_Check(A,&V,&E);
}
void Add_Ref_Fibers(Long PM[][POLY_Dmax], int *d, int *p, int *v, int *s,
	GL_Long G[][POLY_Dmax][POLY_Dmax], int *n, PolyPointList *A, int r)
{    int i,j,c,l; Long X[VERT_Nmax][VERT_Nmax],x; 	/* n==nf */
     GL_Long Ginv[POLY_Dmax][POLY_Dmax]; 
     for(i=0;i<r;i++)for(j=0;j<*d;j++) X[j][i]=PM[s[i]][j];
     PM_to_GLZ_for_UTriang(X,d,&r,G[*n]); INV_GLZmatrix(G[*n],d,Ginv);
     for(i=0;i<*n;i++) 				/* check if already found */
     {	int newfib=0; for(j=r;j<*d;j++) for(c=0;c<r;c++)
	{   x=0; for(l=0;l<*d;l++) x+=G[i][j][l]*Ginv[l][c]; if(x)newfib=1;
	}   if(!newfib) return;
     }  if(Fiber_Ref_Check(PM,d,p,v,G[*n],Ginv,X,A,r))
     {	assert(*n < VERT_Nmax); (*n)++; }
}

typedef struct {GL_Long G[VERT_Nmax][POLY_Dmax][POLY_Dmax],
		GK[VERT_Nmax][POLY_Dmax][POLY_Dmax],
		B[VERT_Nmax][POLY_Dmax][POLY_Dmax];
		int nf; PolyPointList F;}			     ek3fli;
void Fiber_Rec_New_Point(PolyPointList *_P, int *v,/* already selected r pts */
	GL_Long ***G, GL_Long *GI[POLY_Dmax][POLY_Dmax], GL_Long **GN,
	GL_Long T[][POLY_Dmax], int *s, int r, ek3fli *F, int *fdim)
{    int i,j,k,*d=&_P->n,*n=&s[r],p=_P->np-1; GL_Long *X=T[r]; 
     for(*n=s[r-1]+1; *n<_P->np-(*fdim)+r; (*n)++)
     {	Long *P=_P->x[*n]; for(i=0;i<*d;i++)
	{   X[i]=0; for(j=0;j<*d;j++) X[i]+=G[r-1][i][j]*P[j];
	}   for(j=r;j<*d;j++) if(X[j]) break;
	if(j<*d) 			      /* non-zero :: rank increased */
	{   X[r]=GL_V_to_GLZ(&X[r],GN,*d-r); for(i=r+1;i<*d;i++) X[i]=0;
	    for(i=r;i<*d;i++) for(j=0;j<*d;j++) { G[r][i][j]=0;
		for(k=0;k<*d-r;k++)G[r][i][j]+=GN[i-r][k]*G[r-1][r+k][j];}
            if(r<(*fdim)-1) Fiber_Rec_New_Point(_P,v,G,GI,GN,T,s,r+1,F,fdim);
	    else Add_Ref_Fibers(_P->x,d,&p,v,s,F->G,&F->nf,&F->F,r+1);
	}
     }
}
void Reflexive_Fibrations(PolyPointList *P, int nv, ek3fli *F,int fdim) 
{    int n, i, j, d=P->n, s[POLY_Dmax];
     GL_Long T[POLY_Dmax+1][POLY_Dmax],*X=T[0], **G[POLY_Dmax],*GN[POLY_Dmax],
	*GI[POLY_Dmax][POLY_Dmax], GX[(POLY_Dmax*(POLY_Dmax+3))/2][POLY_Dmax];
     F->nf=0; for(j=0;j<d;j++) GN[j]=GX[j];    /* init GLZ pointers */
     for(n=0;n<d;n++) {for(i=0;i<d;i++)/* G=G-list GN=G-new GI->lines of GX */
        if(i<n) GI[n][i]=GI[n-1][i]; else GI[n][i]=GX[j++]; G[n]=GI[n];}
     for(n=0;n<P->np-fdim;n++)
     {	s[0]=n; for(i=0;i<d;i++) X[i]=P->x[n][i]; GL_V_to_GLZ(X,G[0],d);
	for(i=0;i<d;i++) {X[i]=0; for(j=0;j<d;j++)X[i]+=G[0][i][j]*P->x[n][j];}
	Fiber_Rec_New_Point(P,&nv,G,GI,GN,T,s,1,F,&fdim);
     }
}
void AuxDPolyData(PolyPointList *P,PolyPointList *A,int*v,int*n,int*f)
{    Long X[VERT_Nmax][VERT_Nmax]; EqList E; VertexNumList V;
     assert(Ref_Check(P,&V,&E)); *v=V.nv; EL_to_PPL(&E,A,&P->n); 
     assert(Ref_Check(A,&V,&E)); *f=V.nv; Make_VEPM(A,&V,&E,X); 
     Complete_Poly(X,&E,V.nv,A); *n=A->np;
}
void Test_EK3_Fibration(PolyPointList *P,int edim,
	GL_Long G[POLY_Dmax][POLY_Dmax])
{    int s[VERT_Nmax],t[VERT_Nmax],d=P->n,p=P->np-1; PolyPointList *A; 
     assert(NULL != (A=(PolyPointList*) malloc(sizeof(PolyPointList))));
     {	int i,j,e,k, v,n,f; Long PM[VERT_Nmax][POLY_Dmax]; for(i=0;i<p;i++)
	{   for(j=0;j<d;j++)PM[i][j]=GxP(G[j],P->x[i],&d);
	    while(!PM[i][--j]) if(j==0) break; 
	    if(j<edim) t[i]=0; else if(j==edim) t[i]=1; else t[i]=2;
	}   j=0; 
	for(i=0;i<p;i++) if(t[i]==0)s[j++]=i; e=j;
	for(i=0;i<p;i++) if(t[i]==1)s[j++]=i; k=j;
	for(i=0;i<p;i++) if(t[i]==2)s[j++]=i; fprintf(outFILE,"%d %d  ",d,p); 
        for(i=0;i<e;i++)for(j=0;j<edim;j++)A->x[i][j]=PM[s[i]][j];A->n=edim;
puts("PM");
for(j=0;j<d;j++)for(i=0;i<p;i++) (P->np>20) ? 
fprintf(outFILE,"%2d%s",PM[s[i]][j],(i==p-1) ? "\n" : " ") :
fprintf(outFILE,"%4d%s",PM[s[i]][j],(i==p-1) ? "\n" : " ");
A->np=e;Print_PPL(A,"Elliptic");
	A->np=e;AuxDPolyData(A,A,&v,&n,&f);
	printf("Em:%d %d n:%d %d\n",n,f,e+1,v);
        for(i=0;i<k;i++)for(j=0;j<edim+1;j++) A->x[i][j]=PM[s[i]][j];
A->n=edim+1;A->np=k;Print_PPL(A,"K3");
        A->n=edim+1; A->np=k; AuxDPolyData(A,A,&v,&n,&f);
	printf("  K:%d %d n:%d %d  ",n,f,k+1,v); AuxDPolyData(P,A,&v,&n,&f);
	printf("M:%d %d N:%d %d  pi=",A->np,f,P->np,v);
	for(i=0;i<p;i++)printf("%d",s[i]);puts("");
	for(j=0;j<d;j++)for(i=0;i<p;i++) (P->np>20) ? 
	  fprintf(outFILE,"%2d%s",PM[s[i]][j],(i==p-1) ? "\n" : " ") :
	  fprintf(outFILE,"%4d%s",PM[s[i]][j],(i==p-1) ? "\n" : " ");
     }	free(A);
}

void Print_Elliptic_K3_Fibrations(PolyPointList *P,int edim,
	GL_Long G[VERT_Nmax][POLY_Dmax][POLY_Dmax],int nk)
{    int x,s[VERT_Nmax],t[VERT_Nmax],d=P->n,p=P->np-1; PolyPointList *A; 
     if(nk)assert(NULL != (A=(PolyPointList*) malloc(sizeof(PolyPointList))));
     for(x=0;x<nk;x++)
     {	int i,j,e,k, v,n,f; Long PM[VERT_Nmax][POLY_Dmax]; for(i=0;i<p;i++)
	{   for(j=0;j<d;j++)PM[i][j]=GxP(G[x][j],P->x[i],&d);
	    while(!PM[i][--j]) if(j==0) break; 
	    if(j<edim) t[i]=0; else if(j==edim) t[i]=1; else t[i]=2;
	}   j=0; 
	for(i=0;i<p;i++) if(t[i]==0)s[j++]=i; e=j;
	for(i=0;i<p;i++) if(t[i]==1)s[j++]=i; k=j;
	for(i=0;i<p;i++) if(t[i]==2)s[j++]=i; fprintf(outFILE,"%d %d  ",d,p); 
        for(i=0;i<e;i++)for(j=0;j<edim;j++)A->x[i][j]=PM[s[i]][j];
	A->n=edim; A->np=e; AuxDPolyData(A,A,&v,&n,&f);
	printf("Em:%d %d n:%d %d",n,f,e+1,v);
        for(i=0;i<k;i++)for(j=0;j<edim+1;j++) A->x[i][j]=PM[s[i]][j];
        A->n=edim+1; A->np=k; AuxDPolyData(A,A,&v,&n,&f);
	printf("  Km:%d %d n:%d %d  ",n,f,k+1,v); AuxDPolyData(P,A,&v,&n,&f);
	printf("M:%d %d N:%d %d",A->np,f,P->np,v);
	if(p<=FIB_PERM)
	printf("  p=");for(i=0;i<p;i++)printf("%d",s[i]);
        for(i=0;i<p;i++)for(j=0;j<d;j++)A->x[i][j]=PM[s[i]][j];A->n=d;A->np=p;
	Make_Poly_UTriang(A);
	puts(""); for(j=0;j<d;j++)for(i=0;i<p;i++) (P->np>20) ? 
	  fprintf(outFILE,"%2d%s",A->x[i][j],(i==p-1) ? "\n" : " ") :
	  fprintf(outFILE,"%4d%s",A->x[i][j],(i==p-1) ? "\n" : " ");
     }	if(nk)free(A);
}
void All_CDn_Fibrations(PolyPointList *P,int nv,int cd)
{    int x, fdim=P->n-cd; ek3fli *F = (ek3fli *) malloc ( sizeof(ek3fli) ); 
     PolyPointList *A=&F->F;assert(F!=NULL); Reflexive_Fibrations(P,nv,F,fdim);
     for(x=0;x<F->nf;x++)
     {	int i,j,s[VERT_Nmax],t[VERT_Nmax],d=P->n,p=P->np-1,fn,v,n,f; 
	Long PM[VERT_Nmax][POLY_Dmax]; for(i=0;i<p;i++)
	{   for(j=0;j<d;j++)PM[i][j]=GxP(F->G[x][j],P->x[i],&d);
	    while(!PM[i][--j]) if(j==0) break; if(j<fdim) t[i]=0; else t[i]=1;
	}   j=0; 
	for(i=0;i<p;i++) if(t[i]==0)s[j++]=i; fn=j;
	for(i=0;i<p;i++) if(t[i]==1)s[j++]=i; fprintf(outFILE,"%d %d  ",d,p); 
        for(i=0;i<fn;i++)for(j=0;j<fdim;j++)A->x[i][j]=PM[s[i]][j];A->n=fdim;
	A->np=fn; AuxDPolyData(A,A,&v,&n,&f);
	printf("m:%d %d n:%d %d  ",n,f,fn+1,v); AuxDPolyData(P,A,&v,&n,&f);
	printf("M:%d %d N:%d %d",A->np,f,P->np,v);
	if(p<=FIB_PERM){printf("  p=");for(i=0;i<p;i++)printf("%d",s[i]);}
	puts("");
	for(j=0;j<d;j++)for(i=0;i<p;i++) (P->np>20) ? 
	  fprintf(outFILE,"%2d%s",PM[s[i]][j],(i==p-1) ? "\n" : " ") :
	  fprintf(outFILE,"%4d%s",PM[s[i]][j],(i==p-1) ? "\n" : " ");
     }	free(F);
}

void Print_GLZ(GL_Long G[][POLY_Dmax],int d,const char *c)
{    int i,j; for(i=0;i<d;i++)
     {   printf("%s: ",c); for(j=0;j<d;j++)printf("%3d ",G[i][j]);puts("");}
}
typedef struct {GL_Long x[POLY_Dmax][POLY_Dmax];} DxD; /* workaround for -O3 */
void Elliptic_K3_Fibration(PolyPointList *P, int nv, int edim)
{    int c,e, *d=&P->n,p=P->np-1,cd=P->n-edim, nb=0, nk=0;
     GL_Long  GE[POLY_Dmax][POLY_Dmax], *ge[POLY_Dmax];
     ek3fli *F = (ek3fli *) malloc ( sizeof(ek3fli) ); assert(F!=NULL);
     Reflexive_Fibrations(P,nv,F,edim); for(c=0;c<*d;c++) ge[c]=GE[c];
     for(e=0;e<F->nf;e++) for(c=0;c<P->np-1;c++)
     {	int i,j,nz=0,newf=1; GL_Long *b[POLY_Dmax]; Long X[POLY_Dmax];
	for(i=edim;i<P->n;i++) if((X[i]=GxP(F->G[e][i],P->x[c],&P->n))) nz=1;
	if(nz) /* find new B; compare/add B; BxG-FiberRefCheck; print */
	{   GL_Long Binv[POLY_Dmax][POLY_Dmax];
	    for(i=0;i<cd;i++) b[i]=F->B[nb][i]; 
	    GL_V_to_GLZ(&X[edim],b,cd);
	    INV_GLZmatrix(F->B[nb],&cd,Binv);
     	    for(i=0;i<nb;i++)                      /* check if already found */
     	    {  	int l,C=0; nz=0; for(j=1;j<cd;j++)     /* for(C=0;C<r;C++) */
        	{   GL_Long x=0; for(l=0;l<*d;l++) x+=F->B[i][j][l]*Binv[l][C];
		    if(x) {nz=1; break; }		/* r->1, d->cd */
        	}   if(nz==0) { newf=0; break; }
	    }	if(newf)
	    {	Long VV[VERT_Nmax][VERT_Nmax];
		for(i=0;i<*d;i++)for(j=0;j<*d;j++) GE[i][j]=F->G[e][i][j];
		G_2_BxG(ge,b,d,&edim); INV_GLZmatrix(GE,d,Binv);
		if(Fiber_Ref_Check(P->x,d,&p,&nv,GE,Binv,VV,&F->F,edim+1))
		   {nb++; assert(nb<VERT_Nmax);} /* < VERT_Nmax K3 per ell */
	    }	/* printf("e=%d  c=%d  np=%d  nb=%d\n",e,c,P->np,nb); */
	}	/* printf("e=%d c=%d nb=%d  ",e,c,nb); */
	if(c+2==P->np) 						/* finish e */
	{   int n; for(n=0;n<nb;n++)
	    { for(i=0;i<*d;i++)for(j=0;j<*d;j++)F->GK[nk][i][j]=F->G[e][i][j];
		for(i=0;i<*d;i++) { ge[i]=F->GK[nk][i]; b[i]=F->B[n][i];} 
		G_2_BxG(ge,b,d,&edim); assert(++nk < VERT_Nmax);
/* 	printf("\nTest_EK3: e=%d nf=%d  n=%d nb=%d\n",e,F->nf,n,nb);
	Test_EK3_Fibration(P,edim,F->GK[nk-1]); */
	    }	for(i=0;i<*d;i++) ge[i]=GE[i]; nb=0;
	}
     }	Print_Elliptic_K3_Fibrations(P,edim,F->GK,nk); free(F); 
}
void IP_Simplex_Fiber(Long PM[][POLY_Dmax], int p, int d, /* need PM[i]!=0 */
	FibW *F, int Wmax, int CD) 
{    int n,i,j, s[POLY_Dmax+1]; int *nw=&F->nw;     /* nw=#IP_Simp <= Wmax */
     GL_Long T[POLY_Dmax+1][POLY_Dmax],*X=T[0], **G[POLY_Dmax],*GN[POLY_Dmax],
	*GI[POLY_Dmax][POLY_Dmax], GX[(POLY_Dmax*(POLY_Dmax+3))/2][POLY_Dmax];
     *nw=0; /*s[-1]=-1;*/ for(j=0;j<d;j++)GN[j]=GX[j]; /* init GLZ pointers */
     assert(p<=VERT_Nmax);/* G=G-list GN=G-new GI=ptr. at lines of GX=space */
     F->nf=0; for(n=0;n<d;n++) {for(i=0;i<d;i++)
	if(i<n) GI[n][i]=GI[n-1][i]; else GI[n][i]=GX[j++]; G[n]=GI[n];}
     for(n=0;n<p-1;n++)
     {	s[0]=n; for(i=0;i<d;i++) X[i]=PM[n][i];
        GL_V_to_GLZ(X,G[0],d);
	for(i=0;i<d;i++) {X[i]=0; for(j=0;j<d;j++)X[i]+=G[0][i][j]*PM[n][j];}
	IPS_Rec_New_Vertex(PM,&p,&d,nw,F->W,&Wmax,G,GI,GN,T,s,1,F,&CD);
     }if(!CD)if(*nw<p-d){printf("ERROR: nw=%d < codim=%d\n",*nw,p-d);exit(0);}
     /* if(*nw>p-d) printf("WARNING: nw=%d > #pts-dim=%d\n",*nw,p-d); */
     for(i=0;i<*nw;i++)for(n=0;n<d;n++){Long sum=0;
     for(j=0;j<p;j++)sum+=PM[j][n]*F->W[i][j]; 
     if(sum){printf("At line %d ERROR in W =",n); 
	for(j=0;j<p;j++)printf(" %d",F->W[i][j]);puts("");exit(0);}}
}
void IP_Simplex_Decomp(Long PM[][POLY_Dmax], int p, int d, /* need PM[i]!=0 */
	int *nw,Long W[][VERT_Nmax],int Wmax,int CD) /* nw=#IP_Simp <= Wmax */
{    int n,i,j, s[POLY_Dmax+1]; FibW *FW=NULL;
     GL_Long T[POLY_Dmax+1][POLY_Dmax],*X=T[0], **G[POLY_Dmax],*GN[POLY_Dmax],
	*GI[POLY_Dmax][POLY_Dmax], GX[(POLY_Dmax*(POLY_Dmax+3))/2][POLY_Dmax];
     *nw=0; /*s[-1]=-1;*/ for(j=0;j<d;j++)GN[j]=GX[j]; /* init GLZ pointers */
     assert(p<=VERT_Nmax);/* G=G-list GN=G-new GI=ptr. at lines of GX=space */
     for(n=0;n<d;n++) {for(i=0;i<d;i++)
	if(i<n) GI[n][i]=GI[n-1][i]; else GI[n][i]=GX[j++]; G[n]=GI[n];}
     for(n=0;n<p-1;n++)
     {	s[0]=n; for(i=0;i<d;i++) X[i]=PM[n][i];
        GL_V_to_GLZ(X,G[0],d);
	for(i=0;i<d;i++) {X[i]=0; for(j=0;j<d;j++)X[i]+=G[0][i][j]*PM[n][j];}
	IPS_Rec_New_Vertex(PM,&p,&d,nw,W,&Wmax,G,GI,GN,T,s,1,FW,&CD);
     }if(!CD)if(*nw<p-d){printf("ERROR: nw=%d < codim=%d\n",*nw,p-d);exit(0);}
     /* if(*nw>p-d) printf("WARNING: nw=%d > #pts-dim=%d\n",*nw,p-d); */
     for(i=0;i<*nw;i++)for(n=0;n<d;n++){Long sum=0;
     for(j=0;j<p;j++)sum+=PM[j][n]*W[i][j]; 
     if(sum){printf("At line %d ERROR in W =",n); 
	for(j=0;j<p;j++)printf(" %d",W[i][j]);puts("");exit(0);}}
}
void Aux_Make_Dual_Poly(PolyPointList *P, VertexNumList *V, EqList *E)
{    Long VM[VERT_Nmax][POLY_Dmax]; int i,j, d=P->n, e=E->ne, v=V->nv; 
     assert(e<=VERT_Nmax); P->np=V->nv=e; E->ne=v;
     for(i=0;i<v;i++)for(j=0;j<d;j++) VM[i][j]=P->x[V->v[i]][j]; 
     for(i=0;i<e;i++){for(j=0;j<d;j++)P->x[i][j]=E->e[i].a[j]; V->v[i]=i;}
     for(i=0;i<v;i++){for(j=0;j<d;j++)E->e[i].a[j]=VM[i][j]; E->e[i].c=1;}
     assert(Ref_Check(P,V,E));
}
#undef	TEST
#define	TEST
#undef	TEST_OUT
void Aux_IPS_Print_Poly(PolyPointList *_P, VertexNumList *_V,
	int np,int nw,int VS,int CD)
{    int j; if(VS) Print_VL(_P,_V,"vertices of P-dual and IP-simplices");
     else   Print_PPL(_P,"points of P-dual and IP-simplices");
     for(j=0; j<np; j++) fprintf(outFILE,"-----"); 
     if(CD) fprintf(outFILE,"         fibrations:\n"); 
     else { fprintf(outFILE,"         #=%d",nw); if(nw>np-_P->n)
         fprintf(outFILE," > %d=#pts-dim",np-_P->n);fputs("\n",outFILE);}
}
void Aux_IPS_Print_W(Long *W,int w,int cd)
{    int j, d=0; for(j=0;j<w;j++){fprintf(outFILE," %4d",(int)W[j]);d+=W[j];}
     fprintf(outFILE," %4d=d  codim=%d",d,cd);
}
void Aux_IPS_Print_WP(Long *W,int w,int cd)
{    int j, d=0; for(j=0;j<w;j++){fprintf(outFILE,(w>19) ? " %2d" : " %4d",
	(int)W[j]);d+=W[j];} fprintf(outFILE," %3d=d  codim=%d",d,cd);
}
void Print_Fiber_PolyData(PolyPointList *P,VertexNumList *V,Long *W,int w,
	int n,int nw,int VS,int CD)
{    int cd=0, j, Mmp, Mmv, Mnp, Mnv, Nmp, Nmv, Nnp, Nnv; static int f;
     for(j=0; j<w; j++) if(!W[j]) cd++; cd=cd+P->n-w+1;
     if(CD==0) Aux_IPS_Print_W(W,w,cd); else if(n==0) f=0;

     if(CD||((cd>0)&&(cd<3)&&((P->n)-cd>1)))
     {	int i, s=0, p, D=P->n, d=P->n-cd, fib, ref;
	Long X[VERT_Nmax][VERT_Nmax];
	GL_Long G[POLY_Dmax][POLY_Dmax],Ginv[POLY_Dmax][POLY_Dmax];
	EqList e; VertexNumList v; PolyPointList *F
	    = (PolyPointList *) malloc(sizeof(PolyPointList));assert(F!=NULL);
	for(p=0;p<w;p++)if(W[p]){for(i=0;i<D;i++) X[i][s]=P->x[p][i]; s++;}
#ifdef	TEST_OUT
	{int j; puts("");for(i=0;i<D;i++){printf("X=");
	for(j=0;j<s;j++)printf("%2d ",X[i][j]);puts("");}}
#endif
	PM_to_GLZ_for_UTriang(X,&D,&s,G); INV_GLZmatrix(G,&D,Ginv); 
#ifdef	TEST_OUT
	{int j; puts("");for(i=0;i<D;i++){printf("G[%d]= ",i);
	for(j=0;j<D;j++)printf("%2d ",G[i][j]);printf("    X=");
	for(j=0;j<s;j++)printf("%2d ",X[i][j]);puts("");}}
#endif
	for(p=0;p<V->nv;p++)for(i=0;i<D;i++){GL_Long x=0; for(s=0;s<D;s++)
	    x+=G[i][s]*P->x[V->v[p]][s]; F->x[p][i]=x;}
	F->np=P->np; F->n=D; assert(Ref_Check(F,&v,&e));
	Aux_Make_Dual_Poly(F,&v,&e); Make_VEPM(F,&v,&e,X); 
	Complete_Poly(X,&e,v.nv,F); F->n=d; Remove_Identical_Points(F);
	fib=Ref_Check(F,&v,&e); Mmp=F->np;Mmv=v.nv;Mnv=e.ne; 
	if(fib){Aux_Make_Dual_Poly(F,&v,&e); Make_VEPM(F,&v,&e,X); 
	      Complete_Poly(X,&e,v.nv,F); Mnp=F->np;} else Mnp=0;
	
	if(fib&&CD) {if(f==0){f=1;Aux_IPS_Print_Poly(P,V,w,nw,VS,CD);}
	    Aux_IPS_Print_W(W,w,cd); fprintf(outFILE,
		" fiber m:%d %d n:%d %d\n",Mmp,Mmv,Mnp,Mnv); return;}
	s=0; F->np=P->np;F->n=D; for(p=0;p<w;p++) /* now check ref in N only */
	if(W[p]){for(i=0;i<D;i++) F->x[s][i]=P->x[p][i]; s++;}
	for(p=0;p<w;p++)if(!W[p]){for(i=0;i<D;i++)F->x[s][i]=P->x[p][i]; s++;}
	for(p=w;p<P->np;p++) for(i=0;i<D;i++) F->x[p][i]=P->x[p][i];
	Make_Poly_UTriang(F); 
	s=0; for(p=0;p<P->np;p++)
	{   for(i=d;i<D;i++) if(F->x[p][i]) break;
	    if(i==D) {if(s<p) for(i=0;i<d;i++) F->x[s][i]=F->x[p][i]; s++;}
	}   F->n=d;F->np=s;ref=Ref_Check(F,&v,&e);Nmv=e.ne; Nnp=F->np;Nnv=v.nv;
#ifdef	TEST_OUT
	puts("\nFiber:");Print_PPL(F,"Fiber");
#endif
	if(ref) 
	{   Long PM[VERT_Nmax][VERT_Nmax]; Aux_Make_Dual_Poly(F,&v,&e);
	    Make_VEPM(F,&v,&e,PM); Complete_Poly(PM,&e,v.nv,F); Nmp=F->np;
	    if(fib)fprintf(outFILE," fiber m:%d %d n:%d %d",Mmp,Mmv,Mnp,Mnv);
	    else fprintf(outFILE," m:%d %d f:%d // m:%d %d n:%d %d",
		Mmp,Mmv,Mnv,Nmp,Nmv,Nnp,Nnv);
	}
	else fprintf(outFILE," m:%d %d f:%d // f:%d n:%d %d",
		Mmp,Mmv,Mnv,Nmv,Nnp,Nnv);
	free(F);
     }	fprintf(outFILE,"\n"); 
}
#ifdef OLD_IPS			    /* switch of Check_New_Fiber in ... !!! */
void IP_Simplices(PolyPointList *_P, int nv, int PS,int VS,int CDin){
  int i, nw, np = VS ? nv : _P->np-1; Long W[FIB_Nmax][VERT_Nmax];
  VertexNumList V; V.nv=nv; for (i=0;i<nv;i++) V.v[i]=i; int CD; 
  for (i=V.nv; i<_P->np-1; i++) if(Vec_is_zero(_P->x[i],_P->n)) {
    Swap_Vecs(_P->x[i],_P->x[_P->np-1],_P->n);
    break;} CD=CDin; assert(CD<4);
  IP_Simplex_Decomp(_P->x,np,_P->n,&nw,W,FIB_Nmax,CD);
  if(nw==0) return; 
  if(CD==0) Aux_IPS_Print_Poly(_P,&V,np,nw,VS,CD);
  for(i=0; i<nw; i++) Print_Fiber_PolyData(_P,&V,W[i],np,i,nw,VS,CD);
}
void Check_New_Fiber(Long PM[][POLY_Dmax],int*,int*,int*,int*,int,FibW*)
{    ;}
#else
void Check_New_Fiber(Long PM[][POLY_Dmax],int *p,int *d,int *nw,
	int *s, int r, FibW *F)
{    int i,j,c,l,*n=&F->nf; Long X[VERT_Nmax][VERT_Nmax],x; 
     GL_Long Ginv[POLY_Dmax][POLY_Dmax]; 
     for(i=0;i<r;i++)for(j=0;j<*d;j++) X[j][i]=PM[s[i]][j];
     PM_to_GLZ_for_UTriang(X,d,&r,F->G[*n]); INV_GLZmatrix(F->G[*n],d,Ginv);
     for(i=0;i<*n;i++) if(r==F->r[i])		/* check if already found */
     {	int newfib=0; for(j=r;j<*d;j++) for(c=0;c<r;c++)
	{   x=0; for(l=0;l<*d;l++) x+=F->G[i][j][l]*Ginv[l][c]; if(x)newfib=1;
	}   if(!newfib) {if(!F->PS) F->nw--; return;}
     }
     F->P->np=F->nv; F->P->n=*d; for(i=0;i<F->nv;i++) for(j=0;j<*d;j++)
	F->P->x[i][j]=GxP(F->G[*n][j],PM[i],d); /* reflexivity of projection */
     {	VertexNumList V; EqList E; assert(Ref_Check(F->P,&V,&E));
	EL_to_PPL(&E,F->P,d); F->P->n=r; Remove_Identical_Points(F->P);
	if(Ref_Check(F->P,&V,&E))
	{   assert(*n<VERT_Nmax); F->f[*n]=F->nw-1; F->r[*n]=r; (*n)++;
	}   else if(!F->PS) F->nw--;
     }
}
void Print_Fibrations(PolyPointList *P,FibW *F)
{    int n; char C[VERT_Nmax]; VertexNumList V; EqList E; for(n=0;n<F->nf;n++)
     {	int s[VERT_Nmax], i,r=F->r[n],*d=&P->n,l,c=0,N;	for(i=0;i<P->np-1;i++)
        {   for(l=r;l<*d;l++) if(GxP(F->G[n][l],P->x[i],d)) break; 
	    if(l==*d){for(l=0;l<r;l++)F->P->x[c][l]=GxP(F->G[n][l],P->x[i],d);
		s[c++]=i;}
	}   F->P->np=c; F->P->n=r; assert(Ref_Check(F->P,&V,&E));
	for(i=0;i<P->np-1;i++) C[i]='_'; for(i=0;i<c;i++)C[s[i]]='p'; 
	for(i=0;i<V.nv;i++) C[s[V.v[i]]]='v'; for(i=0;i<P->np-1;i++) 
	    fprintf(outFILE,"%s%c", (P->np>20) ? "  " : "    ",C[i]); 
	N=F->P->np+1; fprintf(outFILE,"  cd=%d  ",*d-r);
	EL_to_PPL(&E,F->P,&r); assert(Ref_Check(F->P,&V,&E)); 
	{   Long X[VERT_Nmax][VERT_Nmax]; Make_VEPM(F->P,&V,&E,X);
	    Complete_Poly(X,&E,V.nv,F->P);}
	fprintf(outFILE,"m:%d %d n:%d %d\n",F->P->np,V.nv,N,E.ne);
     }
}
void IP_Simplices_Docu()
{    puts("Allowed fibration flags: 1 2 3 11n 22n 33n 12n 23n with n=[ 123]");
     printf("1,2,3: only fibrations spanned by IP simplices with codimension");
     puts(" <= 1,2,3\n11,22,33: all fibrations with codimension 1,2,3");
     puts("12,23: all codim-1 fibered fibrations with codimension 1,2");
     puts("NNn with n=1,2,3: same as NN and n\n"); 
     exit(0); 
}
void Print_QuotZ(int Z[][VERT_Nmax],int *M,int p,int n)
{    int i,j; for(i=0;i<n;i++)
     {	fprintf(outFILE," /Z%d:",M[i]);
	for(j=0;j<p;j++) fprintf(outFILE," %d",Z[i][j]);
     }
}
void Print_Quotient(Long *V[VERT_Nmax],int d,int v)
{    Long Z[POLY_Dmax][VERT_Nmax], G[POLY_Dmax][POLY_Dmax], M[POLY_Dmax],
	D[POLY_Dmax]; int i,j,r; 
     fprintf(outFILE," I=%d",Sublattice_Basis(d,v,V,Z,M,&r,G,D));
     for(i=0;i<r;i++)
     {	fprintf(outFILE," /Z%d:",M[i]);
	for(j=0;j<v;j++) fprintf(outFILE," %d",Z[i][j]);
     }
}
void IP_Simplices(PolyPointList *_P, int nv, int PS,int VS,int CDin)
{    int i,j,CD=0,np=_P->np-1; FibW *F = (FibW *) malloc( sizeof(FibW) );
     VertexNumList V; assert(F!=NULL); F->ZS=((PS<0)||(VS<0)); 
     for (i=nv; i<_P->np-1; i++) if(Vec_is_zero(_P->x[i],_P->n)) {
     Swap_Vecs(_P->x[i],_P->x[_P->np-1],_P->n); break;}
     if((CDin<0)||(CDin>333)) IP_Simplices_Docu();     
     if(CDin<10) {CD=CDin; CDin=0;} else if(CDin>99) {CD=CDin % 10; CDin/=10;} 
     switch(CDin){ case 0: case 11: case 22: case 33: case 12: case 23: break;
	default: IP_Simplices_Docu(); }	 if(CD > 3) IP_Simplices_Docu();
     if(VS||CDin)
     {  if(nv) {for(i=0;i<nv;i++) V.v[i]=i; V.nv=nv;} else 
	{   EqList E; assert(Ref_Check(_P,&V,&E)); nv=V.nv-1;
	    for(i=0;i<nv;i++) for(j=i+1;j<V.nv;j++)
	    if(V.v[i]>V.v[j]) swap(&V.v[i],&V.v[j]); nv=V.v[V.nv-1]+1;
	}
     }
     if(VS)
     {	Print_VL(_P,&V,"vertices of P-dual and IP-simplices");
	for(i=0; i<V.nv; i++) fprintf(outFILE,"-----");
	if(V.nv==nv) IP_Simplex_Fiber(_P->x,nv,_P->n,F,FIB_Nmax,0); else
	{   Long P[VERT_Nmax][POLY_Dmax];
	    for(i=0;i<V.nv;i++)for(j=0;j<_P->n;j++)P[i][j]=_P->x[V.v[i]][j];
	    IP_Simplex_Fiber(P,V.nv,_P->n,F,FIB_Nmax,0);
	}
	fprintf(outFILE,"   #IP-simp=%d",F->nw); if(F->nw>V.nv-_P->n)
	fprintf(outFILE," > %d=#pts-dim",V.nv-_P->n); 
	if(F->ZS)
        {   Long *pl[VERT_Nmax]; for(i=0;i<V.nv;i++)pl[i]=_P->x[V.v[i]];
	    Print_Quotient(pl,_P->n,V.nv);
	}   fputs("\n",outFILE);
	for(i=0; i<F->nw; i++)
	{   int cd=_P->n-V.nv+1 ; for(j=0;j<V.nv;j++) if(!F->W[i][j]) cd++;
	    Aux_IPS_Print_W(F->W[i],V.nv,cd);   if(F->ZS) if(F->nz[i])
		Print_QuotZ(&F->Z[F->n0[i]],&F->M[F->n0[i]],nv,F->nz[i]);
	    fprintf(outFILE,"\n");
	}
     }	if(CD) 
     {  F->P=(PolyPointList *)malloc(sizeof(PolyPointList));
	assert(F->P!=NULL); F->PS=PS; F->nv=nv;
     }	if(CD||PS)
     {	/* if(CD)*/ IP_Simplex_Fiber(_P->x,np,_P->n,F,FIB_Nmax,CD);
	/* else IP_Simplex_Decomp(_P->x,np,_P->n,&F->nw,F->W,FIB_Nmax,CD);*/
	if(F->nw) { fprintf(outFILE,"%d %d  %s\n",_P->n,_P->np,
	    "points of P-dual and IP-simplices"); for(i=0;i<_P->n;i++) 
	    {	for(j=0;j<_P->np;j++) fprintf(outFILE,(_P->np>20) ? " %2d" :
		" %4d", (int)_P->x[j][i]);fprintf(outFILE,"\n");}}
	if(PS)
	{   for(i=0; i<np; i++) fprintf(outFILE,(np>20) ? "---" : "-----");
	    fprintf(outFILE,"    #IP-simp=%d",F->nw); if(F->nw>np-_P->n)
	    fprintf(outFILE," > %d=#pts-dim",np-_P->n); fputs("\n",outFILE);
	    for(i=0; i<F->nw; i++)
	    {   int cd=_P->n-np+1 ; for(j=0;j<np;j++) if(!F->W[i][j]) cd++;
	        Aux_IPS_Print_WP(F->W[i],np,cd); if(F->ZS) if(F->nz[i]) 
		Print_QuotZ(&F->Z[F->n0[i]],&F->M[F->n0[i]],np,F->nz[i]);
		fprintf(outFILE,"\n");
	    }
	}    
	if(CD)
	{   for(i=0; i<np; i++) fprintf(outFILE, (np>20) ? "---" : "-----");
	    fprintf(outFILE,"    #fibrations=%d",F->nf); fputs("\n",outFILE);
	    Print_Fibrations(_P,F);
	}
     }
     if(CDin) switch(CDin){
	case 11:	All_CDn_Fibrations(_P,nv,1);	break;
	case 22:	All_CDn_Fibrations(_P,nv,2); 	break;
	case 33:	All_CDn_Fibrations(_P,nv,3); 	break;
	case 12:	Elliptic_K3_Fibration(_P,nv,_P->n-2); break;
	case 23:	Elliptic_K3_Fibration(_P,nv,_P->n-3); break; }
     if(CD) free(F->P); free(F); return; 
}
void IP_Fiber_Data(PolyPointList *PD,PolyPointList *AuxP,int nv,/* PD::N-lat.*/
     Long G[VERT_Nmax][POLY_Dmax][POLY_Dmax],int fd[VERT_Nmax],int *nf,int CD)
{    int i,j,k; FibW *F = (FibW *) malloc ( sizeof(FibW) ); assert(NULL != F);
     F->P=AuxP; F->PS=F->ZS=0; F->nv=nv;
     IP_Simplex_Fiber(PD->x,PD->np-1,PD->n,F,FIB_Nmax,CD); *nf=F->nf; 
     for(i=0;i<*nf;i++) { fd[i]=F->r[i];
	for(j=0;j<PD->n;j++)for(k=0;k<PD->n;k++) G[i][j][k]=F->G[i][j][k];
     }	free(F);
}					/* aux routine for nef package */
#endif
/*      =============================================================       */

/*      =============================================================       */
/* find GLZ G such that G*P generates a diagonal basis D;  basis = Ginv x D */
/*   minimum of column gcd's -> basis vector -> while(line-entry%g) reduce  */
Long AuxColGCD(int *d, int l, GL_Long G[][POLY_Dmax], Long *X)
{    Long g=labs(GxP(G[l],X,d)), x; 
     while(++l<*d) if(x=labs(GxP(G[l],X,d))) g=(g) ? Fgcd(g,x) : x; return g;
}
void Normalize_Diagonal(int *d, Long *D, GL_Long **G)
{    int a,b,i; for(a=0;a<*d-1;a++) for(b=a+1;b<*d;b++) if(D[b]%D[a])
     {	GL_Long A, B, g=GL_Egcd(D[a],D[b],&A,&B), X=-D[b]/g, Y=D[a]/g, L; 
	D[b]*=D[a]/g; D[a]=g; for(i=0;i<*d;i++)
	{   L=A*G[a][i]+B*G[b][i]; G[b][i]=X*G[a][i]+Y*G[b][i]; G[a][i]=L;
	}
     }	for(i=1;i<*d;i++) assert((D[i]%D[i-1])==0);
}
int  GL_Lattice_Basis(int d, int p, Long *P[POLY_Dmax],    /* return index */
	GL_Long GM[][POLY_Dmax], Long *D, GL_Long BM[][POLY_Dmax])
{    int L,C; Long g,a,index=1, V[POLY_Dmax], *G[POLY_Dmax], *B[POLY_Dmax]; 
     static int x;x++; for(L=0;L<d;L++){V[L]=P[0][L]; G[L]=GM[L]; B[L]=BM[L];}
     for(L=0;L<d;L++)for(C=0;C<d;C++)G[L][C]=(L==C); for(L=0;L<d-1;L++)
     {	int l,c; g=0; for(C=0;C<p;C++) if(a=labs(AuxColGCD(&d,L,GM,P[C])))
	{   if(a==1)
	    {   for(l=L;l<d;l++)V[l]=GxP(G[l],P[C],&d); g=GL_V_to_GLZ(&V[L],B,
		   d-L); G_2_BxG(G,B,&d,&L); c=p; break;  /* P[c] -> B, G.B */
	    }
	    else					 /* search best gcd */
	    {   if((g==0)||(a<g)) {g=a; c=C;}
	    }
	}
	if(c<p)					  /* check for divisibility */
	{   for(l=L;l<d;l++)V[l]=GxP(G[l],P[c],&d);g=GL_V_to_GLZ(&V[L],B,d-L);
	    G_2_BxG(G,B,&d,&L);  			  /* P[c] -> B, G.B */
	    for(C=0;C<p;C++) if((a=GxP(G[L],P[C],&d)) % g)  /* improve line */
	    {	Long vg,va; V[L]=Egcd(g,a,&vg,&va);
		for(l=L+1;l<d;l++) V[l]=va*GxP(G[l],P[C],&d);
		assert(0==g % (vg=GL_V_to_GLZ(&V[L],B,d-L)));
		g=vg; c=C; C=0; G_2_BxG(G,B,&d,&L);
	    }			      /* C==p if finished with improvements */
	}   D[L]=g; index*=g;
     }  g=0; assert(L==d-1);
	for(C=0;C<p;C++) if(a=labs(GxP(G[L],P[C],&d))) g=(g)? Fgcd(g,a) : a;
	D[L]=g; index*=g; Normalize_Diagonal(&d,D,G); INV_GLZmatrix(GM,&d,BM);
     return index;
}
int  Make_Lattice_Basis(int d, int p, Long *P[POLY_Dmax],  /* index=det(D) */
	Long G[][POLY_Dmax], Long *D) /* G x P generates diagonal lattice D */
{    int i,j,I; GL_Long GLG[POLY_Dmax][POLY_Dmax], Ginv[POLY_Dmax][POLY_Dmax];
     I=GL_Lattice_Basis(d,p,P,GLG,D,Ginv);
     for(i=0;i<d;i++)for(j=0;j<d;j++) G[i][j]=GLG[i][j]; return I;
}
void QuotZ_2_SublatG(Long Z[][POLY_Dmax],int *m,int *M,int *d,
     Long G[][POLY_Dmax]) 		      /* normalize and diagonalize Z */
{    int i,j,k,r;GL_Long GT[POLY_Dmax][POLY_Dmax],Ginv[POLY_Dmax][POLY_Dmax];
     Long g, A[POLY_Dmax][VERT_Nmax]; 
#ifdef	TEST_QZ
	for(i=0;i<*m;i++){for(j=0;j<*d;j++)printf("%2d  ",Z[i][j]);
	printf("/%d  input\n",M[i]);}
#endif
     for(i=0;i<*m;i++)
     {	g=labs(Z[i][0]); for(j=1;j<*d;j++)if(Z[i][j])g=Fgcd(g,labs(Z[i][j]));
	if(g!=1) {printf("Non-effective group action [%d]\n",i);exit(0);}
     }
     for(i=0;i<*m-1;i++)for(j=*m-1;j>i;j--) /* reduce: (g1.g2)  m=lcm(m1,m2) */
     {	int mi,mj;Long *Zi,*Zj;g=Fgcd(M[i],M[j]);/* g2^(m2/m') m'=gcd(m1,m2) */
	mi=M[i]/g; mj=M[j]/g; Zi=Z[i]; Zj=Z[j]; M[i]*=mj; M[j]=g;
	for(k=0;k<*d;k++)
	{   Zi[k]=mj*Zi[k]+mi*Zj[k]; if((Zi[k]%=M[i])<0) Zi[k]+=M[i];
	    if(M[j]>1) {if((Zj[k]%=M[j])<0) Zj[k]+=M[j];}
	}   
     }  while(M[*m-1]==1)(*m)--; assert(*m>0);for(i=0;i<*m;i++)assert(M[i]>1);
     for(i=0;i<*m;i++) {Long *Zi=Z[i]; for(j=0;j<*d;j++) 
     {	if((Zi[j]%=M[i]) < 0) Zi[j]+=M[i]; A[j][i]=Zi[j];}}
     r=PM_to_GLZ_for_UTriang(A,d,m,GT); INV_GLZmatrix(GT,d,Ginv);
     for(i=0;i<*d;i++)for(j=0;j<*d;j++)G[i][j]=Ginv[j][i];/* Z*G lower trian */
#ifdef	TEST_QZ
	printf("rank=%d  m=%d\n",r,*m);
	for(i=0;i<*m;i++){for(j=0;j<*d;j++)printf("%2d  ",Z[i][j]);
	printf("/%d  normalized\n",M[i]);}
        for(i=0;i<*m;i++){for(j=0;j<*d;j++)printf("%2d  ",GxP(GT[j],Z[i],d));
	printf("/%d  Z*G diagonal\n",M[i]);}
        for(i=0;i<*d;i++){for(j=0;j<*d;j++)printf("%2d  ",G[i][j]);
	printf("=G[%d]\n",i);}
	/*   *m=0; for(i=0;i<*d;i++)for(j=0;j<*d;j++)G[i][j]=(i==j); */
#endif
     assert((*m) == r);
}

void Normalize_QuotientZ(int *r,int *p,Long Z[POLY_Dmax][VERT_Nmax],Long *M)
{    int i,j,k; Long g=M[0]; for(i=1;i<*r;i++)g*=M[i]; assert(g>0);
     if(g==1) {*r=0; return;}
     for(i=0;i<*r-1;i++)for(j=*r-1;j>i;j--) /* reduce: (g1.g2)  m=lcm(m1,m2) */
     {	Long g=Fgcd(M[i],M[j]);			/* g2^(m2/m')  m'=gcd(m1,m2) */
	int mi=M[i]/g, mj=M[j]/g; Long *Zi=Z[i], *Zj=Z[j]; M[i]*=mj; M[j]=g;
	for(k=0;k<*p;k++)
	{   Zi[k]=mj*Zi[k]+mi*Zj[k]; if((Zi[k]%=M[i])<0) Zi[k]+=M[i];
	    if(M[j]>1) {if((Zj[k]%=M[j])<0) Zj[k]+=M[j];}
	}   
     }  while(M[*r-1]==1)(*r)--; assert(*r>0);for(i=0;i<*r;i++)assert(M[i]>1);
     for(i=0;i<*r;i++) {Long *Zi=Z[i]; for(j=0;j<*r;j++) 
     {	if((Zi[j]%=M[i]) < 0) Zi[j]+=M[i];}}
}
int  GL_Lattice_Basis_QZ(int d,int p, Long *P[VERT_Nmax], Long *D, /* index */
	Long Z[][VERT_Nmax], Long *M, int *r, 
	GL_Long GM[][POLY_Dmax], GL_Long BM[][POLY_Dmax]);
/*   PM_2_Quotie ... general purpose making quotients from PointMatrix
 *   Aux_Mat_2_Q ... translating triantular form on T[s[i]] ... onto FibW
 */
int  PM_2_QuotientZ(Long PM[VERT_Nmax][POLY_Dmax], int *d, int *p,
	Long Z[POLY_Dmax][VERT_Nmax], Long M[POLY_Dmax], int *n)
{    int i,j,I,rk=0; GL_Long G[POLY_Dmax][POLY_Dmax],B[POLY_Dmax][POLY_Dmax]; 
     Long D[POLY_Dmax],*P[VERT_Nmax];for(j=0;j<*p;j++)P[j]=PM[j];
     for(i=0;i<*d;i++)for(j=0;j<*p;j++)Z[i][j]=PM[j][i];
     *n=PM_to_GLZ_for_UTriang(Z,d,p,G); 
     if(*n<*d) for(i=0;i<*n;i++)for(j=0;j<*p;j++)
     {	PM[j][i]=0; for(I=0;I<*d;I++)PM[j][i]+=G[i][I]*Z[I][j];
     }	
	I=GL_Lattice_Basis_QZ(*n,*p,P,D,Z,M,&rk,G,B);  
#ifdef TEST_OUT
     puts("PM_2_QuotientZ:\n"); for(i=0;i<rk;i++) 
	printf("%d ",M[i]) ;printf("  index=%d\n",I); for(i=0;i<rk;i++)
	{for(j=0;j<*p;j++)printf("%3d ",GxP(G[i],PM[j],d)); printf("=GxP Z%d="
	,M[i]);for(j=0;j<*p;j++)printf(" %2d",Z[i][j]);puts("");}
#endif
     *n=rk; return I;
}
void Aux_Mat_2_QuotientZ(GL_Long T[][POLY_Dmax],int *D,int *np,int *d,int *s,
	FibW *F)
{    int i,j, rk,p=*d+1, *z[POLY_Dmax], *m;
     Long PM[VERT_Nmax][POLY_Dmax], M[POLY_Dmax], Z[POLY_Dmax][VERT_Nmax];
     for(i=0;i<*D;i++) for(j=0;j<p;j++) PM[j][i]=T[j][i];
#ifdef	TEST_out
	{int i,j,dd=*D,pp=p;for(i=0;i<dd;i++){for(j=0;j<pp;j++)
		printf("%3d",PM[j][i]);puts(" =PM2in");}}
#endif
     PM_2_QuotientZ(PM,D,&p,Z,M,&rk); 		assert(F->nw>0);
#ifdef	TEST_out
	{int i,j,dd=rk,pp=p;for(i=0;i<dd;i++){for(j=0;j<pp;j++)
		printf("%3d",PM[j][i]);puts(" =PM2out");}}
#endif
     F->n0[F->nw-1] = (F->nw>1) ? (F->n0[F->nw-2]+F->nz[F->nw-2]) : 0;
     F->nz[F->nw-1] = rk; assert(F->n0[F->nw-1]+F->nz[F->nw-1] <= VERT_Nmax);
     j=F->n0[F->nw-1]; for(i=0;i<rk;i++) {z[i]=F->Z[j+i]; m=&F->M[j];}
/*	assert(rk>=0);printf("rk=%d s[0]=%d i=%d j=%d\n",rk,s[0],i,j); */
     for(i=0;i<rk;i++)for(j=0;j<*np;j++)z[i][j]=0; for(i=0;i<rk;i++)m[i]=M[i];
     for(i=0;i<rk;i++)for(j=0;j<p;j++) z[i][s[j]]=Z[i][j];
#ifdef	TEST_out
			printf("F->nw=%d\n",F->nw);
	for(i=0;i<rk;i++) { printf("Z%d:",M[i]);
	for(j=0;j<p;j++) printf(" %2d",Z[i][j]); puts("");}
#endif
     return;
}
int  TriMat_to_WeightZ(GL_Long T[][POLY_Dmax], int *d,int *p,int r,int *s,
	int *nw, Long W[][VERT_Nmax], int *Wmax, FibW *F)
{    if(TriMat_to_Weight(T,p,r,s,nw,W,Wmax))
     {	if(F!=NULL) if(F->ZS) Aux_Mat_2_QuotientZ(T,d,p,&r,s,F); return 1;
     }	else return 0;
}
int  GL_Lattice_Basis_QZ(int d,int p, Long *P[VERT_Nmax], Long *D, /* index */
	Long Z[][VERT_Nmax], Long *M, int *r, 
	GL_Long GM[][POLY_Dmax], GL_Long BM[][POLY_Dmax])
{    Long g,a,index=1, *Y, V[POLY_Dmax], *G[POLY_Dmax], *B[POLY_Dmax]; 
     int L, C, tz=(p<VERT_Nmax); Long GP[VERT_Nmax][POLY_Dmax], A[VERT_Nmax];
     for(L=0;L<d;L++){G[L]=GM[L]; B[L]=BM[L]; for(C=0;C<d;C++)G[L][C]=(L==C);}
     for(L=0;L<d-1;L++)
     {	int l,c; g=0; for(C=0;C<p;C++) if(a=labs(AuxColGCD(&d,L,GM,P[C])))
	{   if(a==1)
	    {   for(l=L;l<d;l++)V[l]=GxP(G[l],P[C],&d); g=GL_V_to_GLZ(&V[L],B,
		   d-L); G_2_BxG(G,B,&d,&L); c=p; break;  /* P[c] -> B, G.B */
	    }
	    else					 /* search best gcd */
	    {   if((g==0)||(a<g)) {g=a; c=C;}
	    }
	}   
	if(tz)					/* action :: lattice basis */
	{    for(l=0;l<p;l++) A[l]=0; A[(c<p) ? c : C] = 1;
	} 
	if(c<p)					  /* check for divisibility */
	{   for(l=L;l<d;l++)V[l]=GxP(G[l],P[c],&d);g=GL_V_to_GLZ(&V[L],B,d-L);
	    G_2_BxG(G,B,&d,&L);  			  /* P[c] -> B, G.B */
	    for(C=0;C<p;C++) if((a=GxP(G[L],P[C],&d)) % g)  /* improve line */
	    {	Long vg,va; V[L]=Egcd(g,a,&vg,&va);
		if(tz) {for(l=0;l<p;l++) A[l]*=vg; A[C]+=va;}
		for(l=L+1;l<d;l++) V[l]=va*GxP(G[l],P[C],&d);
		assert(0==g % (vg=GL_V_to_GLZ(&V[L],B,d-L)));
		g=vg; c=C; C=0; G_2_BxG(G,B,&d,&L);
	    }			      /* C==p if finished with improvements */
	}   D[L]=g; index*=g; if(tz) 	      /* tz::compute GP[L], A, Z[L] */
	{   for(c=0;c<p;c++) GP[c][L]=GxP(G[L],P[c],&d); Y=Z[L];
	    for(l=0;l<=L;l++){V[l]=0;for(c=0;c<p;c++)V[l]+=A[c]*GP[c][l];}
#ifdef TEST
	    for(l=L+1;l<d;l++) {V[l]=0;for(c=0;c<p;c++) 
		V[l]+=A[c]*GxP(G[l],P[c],&d); assert(V[l]==0);}
#endif
	    assert(V[L]==g); for(c=0;c<p;c++) Y[c]=A[c]; for(l=0;l<L;l++)
            {   Long R=0; for(c=0;c<p;c++) R+=A[c]*GP[c][l]; 
		/* printf("V[%d]=%d  R[%d]=%d/%d\n",l,V[l],l,R,D[l]); */
		R/=D[l]; for(c=0;c<p;c++) Y[c]-=R*Z[l][c];
            }
	}
     }  assert(L==d-1); /* for(C=0;C<p;C++) GP[C][L]=GxP(G[L],P[C],&d); */

	if(tz) 
	{   int c,l; Long vg,va; for(C=0;C<p;C++) GP[C][L]=GxP(G[L],P[C],&d); 
	    Y=Z[L]; C=0; while(!GP[C][L]) assert(C++ < p);
	    g=GP[C][L]; for(c=0;c<p;c++) A[c]=0; A[C]=1; for(c=C+1;c<p;c++)
	    {	if((a=GP[c][L]) % g) {g = Egcd(g,a,&vg,&va);
	for(l=C;l<p;l++) A[l]*=vg; A[c]+=va;}
	    }   if(g<0){g=-g; for(c=0;c<p;c++) A[c]*=-1;}
	index*=D[L]=g; for(c=0;c<p;c++) Y[c]=A[c]; for(l=0;l<L;l++)
            {   Long R=0; for(c=0;c<p;c++) {
		/* printf("GP[c][%d]=%d  R[%d]=%d/%d\n",l,GP[c][l],l,R,D[l]);*/
		R+=A[c]*GP[c][l]; 		}
		R/=D[l]; for(c=0;c<p;c++) Y[c]-=R*Z[l][c];
            }
	    for(L=0;L<d;L++) for(l=0;l<d;l++)		/* test Z.GP == D */
	    {   g=0;for(c=0;c<p;c++)g+=Z[L][c]*GP[c][l];assert(g==D[l]*(l==L));
	    }   for(l=0;l<d;l++)
	    {   if(D[l]>1)for(c=0;c<p;c++)if((Z[l][c]%=D[l])<0)Z[l][c]+=D[l];
	    }   
	}   else
	{   g=0; for(C=0;C<p;C++) if(a=labs(GxP(G[L],P[C],&d))) 
		g = (g) ? Fgcd(g,a) : a; index *= D[L]=g; if(index!=1)
	    {puts("Unexpected case in GL_Lattice_Basis_QZ");exit(0);}
	}   *r = (index==1) ? 0 : d;
#ifdef TEST
	if(tz)for(L=0;L<d;L++)for(C=0;C<p;C++)assert(GP[C][L]%D[L]==0);
#endif
     for(L=0;L<d;L++)M[L]=D[L]; Normalize_QuotientZ(r,&p,Z,M);
     Normalize_Diagonal(&d,D,G); INV_GLZmatrix(GM,&d,BM); return index;
}

int  Sublattice_Basis(int d, int p, Long *P[],              /* index=det(D) */
	Long Z[][VERT_Nmax], Long *M, int *r,
	Long G[][POLY_Dmax], Long *D) /* G x P generates diagonal lattice D */
{    int i,j,I; GL_Long GLG[POLY_Dmax][POLY_Dmax], Ginv[POLY_Dmax][POLY_Dmax];
     I=GL_Lattice_Basis_QZ(d,p,P,D, Z,M,r, GLG,Ginv);
     for(i=0;i<d;i++)for(j=0;j<d;j++) G[i][j]=GLG[i][j]; return I;
}
